# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
"""
This file contains the exact signatures for all functions in module
PySide6.QtWidgets, except for defaults which are replaced by "...".
"""

# mypy: disable-error-code="override, overload-overlap"
# Module `PySide6.QtWidgets`

import PySide6.QtWidgets
import PySide6.QtCore
import PySide6.QtGui

import enum
import typing
from PySide6.QtCore import Signal
from shiboken6 import Shiboken


class QAbstractButton(PySide6.QtWidgets.QWidget):

    clicked                  : typing.ClassVar[Signal] = ... # clicked(); clicked(bool)
    pressed                  : typing.ClassVar[Signal] = ... # pressed()
    released                 : typing.ClassVar[Signal] = ... # released()
    toggled                  : typing.ClassVar[Signal] = ... # toggled(bool)


class QAbstractGraphicsShapeItem(PySide6.QtWidgets.QGraphicsItem): ...


class QAbstractItemDelegate(PySide6.QtCore.QObject):

    closeEditor              : typing.ClassVar[Signal] = ... # closeEditor(QWidget*,QAbstractItemDelegate::EndEditHint); closeEditor(QWidget*)
    commitData               : typing.ClassVar[Signal] = ... # commitData(QWidget*)
    sizeHintChanged          : typing.ClassVar[Signal] = ... # sizeHintChanged(QModelIndex)

    class EndEditHint(enum.Enum):

        NoHint                    = 0x0
        EditNextItem              = 0x1
        EditPreviousItem          = 0x2
        SubmitModelCache          = 0x3
        RevertModelCache          = 0x4


class QAbstractItemView(PySide6.QtWidgets.QAbstractScrollArea):

    activated                : typing.ClassVar[Signal] = ... # activated(QModelIndex)
    clicked                  : typing.ClassVar[Signal] = ... # clicked(QModelIndex)
    doubleClicked            : typing.ClassVar[Signal] = ... # doubleClicked(QModelIndex)
    entered                  : typing.ClassVar[Signal] = ... # entered(QModelIndex)
    iconSizeChanged          : typing.ClassVar[Signal] = ... # iconSizeChanged(QSize)
    pressed                  : typing.ClassVar[Signal] = ... # pressed(QModelIndex)
    viewportEntered          : typing.ClassVar[Signal] = ... # viewportEntered()

    class CursorAction(enum.Enum):

        MoveUp                    = 0x0
        MoveDown                  = 0x1
        MoveLeft                  = 0x2
        MoveRight                 = 0x3
        MoveHome                  = 0x4
        MoveEnd                   = 0x5
        MovePageUp                = 0x6
        MovePageDown              = 0x7
        MoveNext                  = 0x8
        MovePrevious              = 0x9

    class DragDropMode(enum.Enum):

        NoDragDrop                = 0x0
        DragOnly                  = 0x1
        DropOnly                  = 0x2
        DragDrop                  = 0x3
        InternalMove              = 0x4

    class DropIndicatorPosition(enum.Enum):

        OnItem                    = 0x0
        AboveItem                 = 0x1
        BelowItem                 = 0x2
        OnViewport                = 0x3

    class EditTrigger(enum.Flag):

        NoEditTriggers            = 0x0
        CurrentChanged            = 0x1
        DoubleClicked             = 0x2
        SelectedClicked           = 0x4
        EditKeyPressed            = 0x8
        AnyKeyPressed             = 0x10
        AllEditTriggers           = 0x1f

    class ScrollHint(enum.Enum):

        EnsureVisible             = 0x0
        PositionAtTop             = 0x1
        PositionAtBottom          = 0x2
        PositionAtCenter          = 0x3

    class ScrollMode(enum.Enum):

        ScrollPerItem             = 0x0
        ScrollPerPixel            = 0x1

    class SelectionBehavior(enum.Enum):

        SelectItems               = 0x0
        SelectRows                = 0x1
        SelectColumns             = 0x2

    class SelectionMode(enum.Enum):

        NoSelection               = 0x0
        SingleSelection           = 0x1
        MultiSelection            = 0x2
        ExtendedSelection         = 0x3
        ContiguousSelection       = 0x4

    class State(enum.Enum):

        NoState                   = 0x0
        DraggingState             = 0x1
        DragSelectingState        = 0x2
        EditingState              = 0x3
        ExpandingState            = 0x4
        CollapsingState           = 0x5
        AnimatingState            = 0x6


class QAbstractScrollArea(PySide6.QtWidgets.QFrame):

    class SizeAdjustPolicy(enum.Enum):

        AdjustIgnored             = 0x0
        AdjustToContentsOnFirstShow = 0x1
        AdjustToContents          = 0x2


class QAbstractSlider(PySide6.QtWidgets.QWidget):

    actionTriggered          : typing.ClassVar[Signal] = ... # actionTriggered(int)
    rangeChanged             : typing.ClassVar[Signal] = ... # rangeChanged(int,int)
    sliderMoved              : typing.ClassVar[Signal] = ... # sliderMoved(int)
    sliderPressed            : typing.ClassVar[Signal] = ... # sliderPressed()
    sliderReleased           : typing.ClassVar[Signal] = ... # sliderReleased()
    valueChanged             : typing.ClassVar[Signal] = ... # valueChanged(int)

    class SliderAction(enum.Enum):

        SliderNoAction            = 0x0
        SliderSingleStepAdd       = 0x1
        SliderSingleStepSub       = 0x2
        SliderPageStepAdd         = 0x3
        SliderPageStepSub         = 0x4
        SliderToMinimum           = 0x5
        SliderToMaximum           = 0x6
        SliderMove                = 0x7

    class SliderChange(enum.Enum):

        SliderRangeChange         = 0x0
        SliderOrientationChange   = 0x1
        SliderStepsChange         = 0x2
        SliderValueChange         = 0x3


class QAbstractSpinBox(PySide6.QtWidgets.QWidget):

    editingFinished          : typing.ClassVar[Signal] = ... # editingFinished()
    returnPressed            : typing.ClassVar[Signal] = ... # returnPressed()

    class ButtonSymbols(enum.Enum):

        UpDownArrows              = 0x0
        PlusMinus                 = 0x1
        NoButtons                 = 0x2

    class CorrectionMode(enum.Enum):

        CorrectToPreviousValue    = 0x0
        CorrectToNearestValue     = 0x1

    class StepEnabledFlag(enum.Flag):

        StepNone                  = 0x0
        StepUpEnabled             = 0x1
        StepDownEnabled           = 0x2

    class StepType(enum.Enum):

        DefaultStepType           = 0x0
        AdaptiveDecimalStepType   = 0x1


class QAccessibleWidget(PySide6.QtGui.QAccessibleObject, PySide6.QtGui.QAccessibleActionInterface): ...


class QApplication(PySide6.QtGui.QGuiApplication):

    focusChanged             : typing.ClassVar[Signal] = ... # focusChanged(QWidget*,QWidget*)


class QBoxLayout(PySide6.QtWidgets.QLayout):

    class Direction(enum.Enum):

        LeftToRight               = 0x0
        RightToLeft               = 0x1
        Down                      = 0x2
        TopToBottom               = 0x2
        BottomToTop               = 0x3
        Up                        = 0x3


class QButtonGroup(PySide6.QtCore.QObject):

    buttonClicked            : typing.ClassVar[Signal] = ... # buttonClicked(QAbstractButton*)
    buttonPressed            : typing.ClassVar[Signal] = ... # buttonPressed(QAbstractButton*)
    buttonReleased           : typing.ClassVar[Signal] = ... # buttonReleased(QAbstractButton*)
    buttonToggled            : typing.ClassVar[Signal] = ... # buttonToggled(QAbstractButton*,bool)
    idClicked                : typing.ClassVar[Signal] = ... # idClicked(int)
    idPressed                : typing.ClassVar[Signal] = ... # idPressed(int)
    idReleased               : typing.ClassVar[Signal] = ... # idReleased(int)
    idToggled                : typing.ClassVar[Signal] = ... # idToggled(int,bool)


class QCalendarWidget(PySide6.QtWidgets.QWidget):

    activated                : typing.ClassVar[Signal] = ... # activated(QDate)
    clicked                  : typing.ClassVar[Signal] = ... # clicked(QDate)
    currentPageChanged       : typing.ClassVar[Signal] = ... # currentPageChanged(int,int)
    selectionChanged         : typing.ClassVar[Signal] = ... # selectionChanged()

    class HorizontalHeaderFormat(enum.Enum):

        NoHorizontalHeader        = 0x0
        SingleLetterDayNames      = 0x1
        ShortDayNames             = 0x2
        LongDayNames              = 0x3

    class SelectionMode(enum.Enum):

        NoSelection               = 0x0
        SingleSelection           = 0x1

    class VerticalHeaderFormat(enum.Enum):

        NoVerticalHeader          = 0x0
        ISOWeekNumbers            = 0x1


class QCheckBox(PySide6.QtWidgets.QAbstractButton):

    checkStateChanged        : typing.ClassVar[Signal] = ... # checkStateChanged(Qt::CheckState)
    stateChanged             : typing.ClassVar[Signal] = ... # stateChanged(int)


class QColorDialog(PySide6.QtWidgets.QDialog):

    colorSelected            : typing.ClassVar[Signal] = ... # colorSelected(QColor)
    currentColorChanged      : typing.ClassVar[Signal] = ... # currentColorChanged(QColor)

    class ColorDialogOption(enum.Flag):

        ShowAlphaChannel          = 0x1
        NoButtons                 = 0x2
        DontUseNativeDialog       = 0x4
        NoEyeDropperButton        = 0x8


class QColormap(Shiboken.Object):

    class Mode(enum.Enum):

        Direct                    = 0x0
        Indexed                   = 0x1
        Gray                      = 0x2


class QColumnView(PySide6.QtWidgets.QAbstractItemView):

    updatePreviewWidget      : typing.ClassVar[Signal] = ... # updatePreviewWidget(QModelIndex)


class QComboBox(PySide6.QtWidgets.QWidget):

    activated                : typing.ClassVar[Signal] = ... # activated(int)
    currentIndexChanged      : typing.ClassVar[Signal] = ... # currentIndexChanged(int)
    currentTextChanged       : typing.ClassVar[Signal] = ... # currentTextChanged(QString)
    editTextChanged          : typing.ClassVar[Signal] = ... # editTextChanged(QString)
    highlighted              : typing.ClassVar[Signal] = ... # highlighted(int)
    textActivated            : typing.ClassVar[Signal] = ... # textActivated(QString)
    textHighlighted          : typing.ClassVar[Signal] = ... # textHighlighted(QString)

    class InsertPolicy(enum.Enum):

        NoInsert                  = 0x0
        InsertAtTop               = 0x1
        InsertAtCurrent           = 0x2
        InsertAtBottom            = 0x3
        InsertAfterCurrent        = 0x4
        InsertBeforeCurrent       = 0x5
        InsertAlphabetically      = 0x6

    class LabelDrawingMode(enum.Enum):

        UseStyle                  = 0x0
        UseDelegate               = 0x1

    class SizeAdjustPolicy(enum.Enum):

        AdjustToContents          = 0x0
        AdjustToContentsOnFirstShow = 0x1
        AdjustToMinimumContentsLengthWithIcon = 0x2


class QCommandLinkButton(PySide6.QtWidgets.QPushButton): ...


class QCommonStyle(PySide6.QtWidgets.QStyle): ...


class QCompleter(PySide6.QtCore.QObject):

    activated                : typing.ClassVar[Signal] = ... # activated(QString); activated(QModelIndex)
    highlighted              : typing.ClassVar[Signal] = ... # highlighted(QString); highlighted(QModelIndex)

    class CompletionMode(enum.Enum):

        PopupCompletion           = 0x0
        UnfilteredPopupCompletion = 0x1
        InlineCompletion          = 0x2

    class ModelSorting(enum.Enum):

        UnsortedModel             = 0x0
        CaseSensitivelySortedModel = 0x1
        CaseInsensitivelySortedModel = 0x2


class QDataWidgetMapper(PySide6.QtCore.QObject):

    currentIndexChanged      : typing.ClassVar[Signal] = ... # currentIndexChanged(int)

    class SubmitPolicy(enum.Enum):

        AutoSubmit                = 0x0
        ManualSubmit              = 0x1


class QDateEdit(PySide6.QtWidgets.QDateTimeEdit):

    userDateChanged          : typing.ClassVar[Signal] = ... # userDateChanged(QDate)


class QDateTimeEdit(PySide6.QtWidgets.QAbstractSpinBox):

    dateChanged              : typing.ClassVar[Signal] = ... # dateChanged(QDate)
    dateTimeChanged          : typing.ClassVar[Signal] = ... # dateTimeChanged(QDateTime)
    timeChanged              : typing.ClassVar[Signal] = ... # timeChanged(QTime)

    class Section(enum.Flag):

        NoSection                 = 0x0
        AmPmSection               = 0x1
        MSecSection               = 0x2
        SecondSection             = 0x4
        MinuteSection             = 0x8
        HourSection               = 0x10
        TimeSections_Mask         = 0x1f
        DaySection                = 0x100
        MonthSection              = 0x200
        YearSection               = 0x400
        DateSections_Mask         = 0x700


class QDial(PySide6.QtWidgets.QAbstractSlider): ...


class QDialog(PySide6.QtWidgets.QWidget):

    accepted                 : typing.ClassVar[Signal] = ... # accepted()
    finished                 : typing.ClassVar[Signal] = ... # finished(int)
    rejected                 : typing.ClassVar[Signal] = ... # rejected()

    class DialogCode(enum.IntEnum):

        Rejected                  = 0x0
        Accepted                  = 0x1


class QDialogButtonBox(PySide6.QtWidgets.QWidget):

    accepted                 : typing.ClassVar[Signal] = ... # accepted()
    clicked                  : typing.ClassVar[Signal] = ... # clicked(QAbstractButton*)
    helpRequested            : typing.ClassVar[Signal] = ... # helpRequested()
    rejected                 : typing.ClassVar[Signal] = ... # rejected()

    class ButtonLayout(enum.Enum):

        WinLayout                 = 0x0
        MacLayout                 = 0x1
        KdeLayout                 = 0x2
        GnomeLayout               = 0x3
        AndroidLayout             = 0x4

    class ButtonRole(enum.Enum):

        InvalidRole               = -1
        AcceptRole                = 0x0
        RejectRole                = 0x1
        DestructiveRole           = 0x2
        ActionRole                = 0x3
        HelpRole                  = 0x4
        YesRole                   = 0x5
        NoRole                    = 0x6
        ResetRole                 = 0x7
        ApplyRole                 = 0x8
        NRoles                    = 0x9

    class StandardButton(enum.Flag):

        NoButton                  = 0x0
        FirstButton               = 0x400
        Ok                        = 0x400
        Save                      = 0x800
        SaveAll                   = 0x1000
        Open                      = 0x2000
        Yes                       = 0x4000
        YesToAll                  = 0x8000
        No                        = 0x10000
        NoToAll                   = 0x20000
        Abort                     = 0x40000
        Retry                     = 0x80000
        Ignore                    = 0x100000
        Close                     = 0x200000
        Cancel                    = 0x400000
        Discard                   = 0x800000
        Help                      = 0x1000000
        Apply                     = 0x2000000
        Reset                     = 0x4000000
        LastButton                = 0x8000000
        RestoreDefaults           = 0x8000000


class QDockWidget(PySide6.QtWidgets.QWidget):

    allowedAreasChanged      : typing.ClassVar[Signal] = ... # allowedAreasChanged(Qt::DockWidgetAreas)
    dockLocationChanged      : typing.ClassVar[Signal] = ... # dockLocationChanged(Qt::DockWidgetArea)
    featuresChanged          : typing.ClassVar[Signal] = ... # featuresChanged(QDockWidget::DockWidgetFeatures)
    topLevelChanged          : typing.ClassVar[Signal] = ... # topLevelChanged(bool)
    visibilityChanged        : typing.ClassVar[Signal] = ... # visibilityChanged(bool)

    class DockWidgetFeature(enum.Flag):

        NoDockWidgetFeatures      = 0x0
        DockWidgetClosable        = 0x1
        DockWidgetMovable         = 0x2
        DockWidgetFloatable       = 0x4
        DockWidgetVerticalTitleBar = 0x8
        DockWidgetFeatureMask     = 0xf
        Reserved                  = 0xff


class QDoubleSpinBox(PySide6.QtWidgets.QAbstractSpinBox):

    textChanged              : typing.ClassVar[Signal] = ... # textChanged(QString)
    valueChanged             : typing.ClassVar[Signal] = ... # valueChanged(double)


class QErrorMessage(PySide6.QtWidgets.QDialog): ...


class QFileDialog(PySide6.QtWidgets.QDialog):

    currentChanged           : typing.ClassVar[Signal] = ... # currentChanged(QString)
    currentUrlChanged        : typing.ClassVar[Signal] = ... # currentUrlChanged(QUrl)
    directoryEntered         : typing.ClassVar[Signal] = ... # directoryEntered(QString)
    directoryUrlEntered      : typing.ClassVar[Signal] = ... # directoryUrlEntered(QUrl)
    fileSelected             : typing.ClassVar[Signal] = ... # fileSelected(QString)
    filesSelected            : typing.ClassVar[Signal] = ... # filesSelected(QStringList)
    filterSelected           : typing.ClassVar[Signal] = ... # filterSelected(QString)
    urlSelected              : typing.ClassVar[Signal] = ... # urlSelected(QUrl)
    urlsSelected             : typing.ClassVar[Signal] = ... # urlsSelected(QList<QUrl>)

    class AcceptMode(enum.Enum):

        AcceptOpen                = 0x0
        AcceptSave                = 0x1

    class DialogLabel(enum.Enum):

        LookIn                    = 0x0
        FileName                  = 0x1
        FileType                  = 0x2
        Accept                    = 0x3
        Reject                    = 0x4

    class FileMode(enum.Enum):

        AnyFile                   = 0x0
        ExistingFile              = 0x1
        Directory                 = 0x2
        ExistingFiles             = 0x3

    class Option(enum.Flag):

        ShowDirsOnly              = 0x1
        DontResolveSymlinks       = 0x2
        DontConfirmOverwrite      = 0x4
        DontUseNativeDialog       = 0x8
        ReadOnly                  = 0x10
        HideNameFilterDetails     = 0x20
        DontUseCustomDirectoryIcons = 0x40

    class ViewMode(enum.Enum):

        Detail                    = 0x0
        List                      = 0x1


class QFileIconProvider(PySide6.QtGui.QAbstractFileIconProvider): ...


class QFileSystemModel(PySide6.QtCore.QAbstractItemModel):

    directoryLoaded          : typing.ClassVar[Signal] = ... # directoryLoaded(QString)
    fileRenamed              : typing.ClassVar[Signal] = ... # fileRenamed(QString,QString,QString)
    rootPathChanged          : typing.ClassVar[Signal] = ... # rootPathChanged(QString)

    class Option(enum.Flag):

        DontWatchForChanges       = 0x1
        DontResolveSymlinks       = 0x2
        DontUseCustomDirectoryIcons = 0x4

    class Roles(enum.IntEnum):

        FileIconRole              = 0x1
        FileInfoRole              = 0xfc
        FilePathRole              = 0x101
        FileNameRole              = 0x102
        FilePermissions           = 0x103


class QFocusFrame(PySide6.QtWidgets.QWidget): ...


class QFontComboBox(PySide6.QtWidgets.QComboBox):

    currentFontChanged       : typing.ClassVar[Signal] = ... # currentFontChanged(QFont)

    class FontFilter(enum.Flag):

        AllFonts                  = 0x0
        ScalableFonts             = 0x1
        NonScalableFonts          = 0x2
        MonospacedFonts           = 0x4
        ProportionalFonts         = 0x8


class QFontDialog(PySide6.QtWidgets.QDialog):

    currentFontChanged       : typing.ClassVar[Signal] = ... # currentFontChanged(QFont)
    fontSelected             : typing.ClassVar[Signal] = ... # fontSelected(QFont)

    class FontDialogOption(enum.Flag):

        NoButtons                 = 0x1
        DontUseNativeDialog       = 0x2
        ScalableFonts             = 0x4
        NonScalableFonts          = 0x8
        MonospacedFonts           = 0x10
        ProportionalFonts         = 0x20


class QFormLayout(PySide6.QtWidgets.QLayout):

    class FieldGrowthPolicy(enum.Enum):

        FieldsStayAtSizeHint      = 0x0
        ExpandingFieldsGrow       = 0x1
        AllNonFixedFieldsGrow     = 0x2

    class ItemRole(enum.Enum):

        LabelRole                 = 0x0
        FieldRole                 = 0x1
        SpanningRole              = 0x2

    class RowWrapPolicy(enum.Enum):

        DontWrapRows              = 0x0
        WrapLongRows              = 0x1
        WrapAllRows               = 0x2

    class TakeRowResult(Shiboken.Object): ...


class QFrame(PySide6.QtWidgets.QWidget):

    class Shadow(enum.IntEnum):

        Plain                     = 0x10
        Raised                    = 0x20
        Sunken                    = 0x30

    class Shape(enum.IntEnum):

        NoFrame                   = 0x0
        Box                       = 0x1
        Panel                     = 0x2
        WinPanel                  = 0x3
        HLine                     = 0x4
        VLine                     = 0x5
        StyledPanel               = 0x6

    class StyleMask(enum.Enum):

        Shape_Mask                = 0xf
        Shadow_Mask               = 0xf0


class QGesture(PySide6.QtCore.QObject):

    class GestureCancelPolicy(enum.Enum):

        CancelNone                = 0x0
        CancelAllInContext        = 0x1


    def __repr__(self, /) -> str: ...


class QGestureEvent(PySide6.QtCore.QEvent): ...
    def __repr__(self, /) -> str: ...


class QGestureRecognizer(Shiboken.Object):

    class ResultFlag(enum.Flag):

        Ignore                    = 0x1
        MayBeGesture              = 0x2
        TriggerGesture            = 0x4
        FinishGesture             = 0x8
        CancelGesture             = 0x10
        ResultState_Mask          = 0xff
        ConsumeEventHint          = 0x100
        ResultHint_Mask           = 0xff00


class QGraphicsAnchor(PySide6.QtCore.QObject): ...


class QGraphicsAnchorLayout(PySide6.QtWidgets.QGraphicsLayout): ...


class QGraphicsBlurEffect(PySide6.QtWidgets.QGraphicsEffect):

    blurHintsChanged         : typing.ClassVar[Signal] = ... # blurHintsChanged(BlurHints)
    blurRadiusChanged        : typing.ClassVar[Signal] = ... # blurRadiusChanged(double)

    class BlurHint(enum.Flag):

        PerformanceHint           = 0x0
        QualityHint               = 0x1
        AnimationHint             = 0x2


class QGraphicsColorizeEffect(PySide6.QtWidgets.QGraphicsEffect):

    colorChanged             : typing.ClassVar[Signal] = ... # colorChanged(QColor)
    strengthChanged          : typing.ClassVar[Signal] = ... # strengthChanged(double)


class QGraphicsDropShadowEffect(PySide6.QtWidgets.QGraphicsEffect):

    blurRadiusChanged        : typing.ClassVar[Signal] = ... # blurRadiusChanged(double)
    colorChanged             : typing.ClassVar[Signal] = ... # colorChanged(QColor)
    offsetChanged            : typing.ClassVar[Signal] = ... # offsetChanged(QPointF)


class QGraphicsEffect(PySide6.QtCore.QObject):

    enabledChanged           : typing.ClassVar[Signal] = ... # enabledChanged(bool)

    class ChangeFlag(enum.Flag):

        SourceAttached            = 0x1
        SourceDetached            = 0x2
        SourceBoundingRectChanged = 0x4
        SourceInvalidated         = 0x8

    class PixmapPadMode(enum.Enum):

        NoPad                     = 0x0
        PadToTransparentBorder    = 0x1
        PadToEffectiveBoundingRect = 0x2


class QGraphicsEllipseItem(PySide6.QtWidgets.QAbstractGraphicsShapeItem): ...


class QGraphicsGridLayout(PySide6.QtWidgets.QGraphicsLayout): ...


class QGraphicsItem(Shiboken.Object):

    class CacheMode(enum.Enum):

        NoCache                   = 0x0
        ItemCoordinateCache       = 0x1
        DeviceCoordinateCache     = 0x2

    class Extension(enum.Enum):

        UserExtension             = 0x80000000

    class GraphicsItemChange(enum.Enum):

        ItemPositionChange        = 0x0
        ItemVisibleChange         = 0x2
        ItemEnabledChange         = 0x3
        ItemSelectedChange        = 0x4
        ItemParentChange          = 0x5
        ItemChildAddedChange      = 0x6
        ItemChildRemovedChange    = 0x7
        ItemTransformChange       = 0x8
        ItemPositionHasChanged    = 0x9
        ItemTransformHasChanged   = 0xa
        ItemSceneChange           = 0xb
        ItemVisibleHasChanged     = 0xc
        ItemEnabledHasChanged     = 0xd
        ItemSelectedHasChanged    = 0xe
        ItemParentHasChanged      = 0xf
        ItemSceneHasChanged       = 0x10
        ItemCursorChange          = 0x11
        ItemCursorHasChanged      = 0x12
        ItemToolTipChange         = 0x13
        ItemToolTipHasChanged     = 0x14
        ItemFlagsChange           = 0x15
        ItemFlagsHaveChanged      = 0x16
        ItemZValueChange          = 0x17
        ItemZValueHasChanged      = 0x18
        ItemOpacityChange         = 0x19
        ItemOpacityHasChanged     = 0x1a
        ItemScenePositionHasChanged = 0x1b
        ItemRotationChange        = 0x1c
        ItemRotationHasChanged    = 0x1d
        ItemScaleChange           = 0x1e
        ItemScaleHasChanged       = 0x1f
        ItemTransformOriginPointChange = 0x20
        ItemTransformOriginPointHasChanged = 0x21

    class GraphicsItemFlag(enum.Flag):

        ItemIsMovable             = 0x1
        ItemIsSelectable          = 0x2
        ItemIsFocusable           = 0x4
        ItemClipsToShape          = 0x8
        ItemClipsChildrenToShape  = 0x10
        ItemIgnoresTransformations = 0x20
        ItemIgnoresParentOpacity  = 0x40
        ItemDoesntPropagateOpacityToChildren = 0x80
        ItemStacksBehindParent    = 0x100
        ItemUsesExtendedStyleOption = 0x200
        ItemHasNoContents         = 0x400
        ItemSendsGeometryChanges  = 0x800
        ItemAcceptsInputMethod    = 0x1000
        ItemNegativeZStacksBehindParent = 0x2000
        ItemIsPanel               = 0x4000
        ItemIsFocusScope          = 0x8000
        ItemSendsScenePositionChanges = 0x10000
        ItemStopsClickFocusPropagation = 0x20000
        ItemStopsFocusHandling    = 0x40000
        ItemContainsChildrenInShape = 0x80000

    class PanelModality(enum.Enum):

        NonModal                  = 0x0
        PanelModal                = 0x1
        SceneModal                = 0x2


    def __repr__(self, /) -> str: ...


class QGraphicsItemAnimation(PySide6.QtCore.QObject): ...


class QGraphicsItemGroup(PySide6.QtWidgets.QGraphicsItem): ...


class QGraphicsLayout(PySide6.QtWidgets.QGraphicsLayoutItem): ...


class QGraphicsLayoutItem(Shiboken.Object): ...


class QGraphicsLineItem(PySide6.QtWidgets.QGraphicsItem): ...


class QGraphicsLinearLayout(PySide6.QtWidgets.QGraphicsLayout): ...


class QGraphicsObject(PySide6.QtCore.QObject, PySide6.QtWidgets.QGraphicsItem):

    childrenChanged          : typing.ClassVar[Signal] = ... # childrenChanged()
    enabledChanged           : typing.ClassVar[Signal] = ... # enabledChanged()
    heightChanged            : typing.ClassVar[Signal] = ... # heightChanged()
    opacityChanged           : typing.ClassVar[Signal] = ... # opacityChanged()
    parentChanged            : typing.ClassVar[Signal] = ... # parentChanged()
    rotationChanged          : typing.ClassVar[Signal] = ... # rotationChanged()
    scaleChanged             : typing.ClassVar[Signal] = ... # scaleChanged()
    visibleChanged           : typing.ClassVar[Signal] = ... # visibleChanged()
    widthChanged             : typing.ClassVar[Signal] = ... # widthChanged()
    xChanged                 : typing.ClassVar[Signal] = ... # xChanged()
    yChanged                 : typing.ClassVar[Signal] = ... # yChanged()
    zChanged                 : typing.ClassVar[Signal] = ... # zChanged()
    def __repr__(self, /) -> str: ...


class QGraphicsOpacityEffect(PySide6.QtWidgets.QGraphicsEffect):

    opacityChanged           : typing.ClassVar[Signal] = ... # opacityChanged(double)
    opacityMaskChanged       : typing.ClassVar[Signal] = ... # opacityMaskChanged(QBrush)


class QGraphicsPathItem(PySide6.QtWidgets.QAbstractGraphicsShapeItem): ...


class QGraphicsPixmapItem(PySide6.QtWidgets.QGraphicsItem):

    class ShapeMode(enum.Enum):

        MaskShape                 = 0x0
        BoundingRectShape         = 0x1
        HeuristicMaskShape        = 0x2


class QGraphicsPolygonItem(PySide6.QtWidgets.QAbstractGraphicsShapeItem): ...


class QGraphicsProxyWidget(PySide6.QtWidgets.QGraphicsWidget): ...


class QGraphicsRectItem(PySide6.QtWidgets.QAbstractGraphicsShapeItem): ...


class QGraphicsRotation(PySide6.QtWidgets.QGraphicsTransform):

    angleChanged             : typing.ClassVar[Signal] = ... # angleChanged()
    axisChanged              : typing.ClassVar[Signal] = ... # axisChanged()
    originChanged            : typing.ClassVar[Signal] = ... # originChanged()


class QGraphicsScale(PySide6.QtWidgets.QGraphicsTransform):

    originChanged            : typing.ClassVar[Signal] = ... # originChanged()
    scaleChanged             : typing.ClassVar[Signal] = ... # scaleChanged()
    xScaleChanged            : typing.ClassVar[Signal] = ... # xScaleChanged()
    yScaleChanged            : typing.ClassVar[Signal] = ... # yScaleChanged()
    zScaleChanged            : typing.ClassVar[Signal] = ... # zScaleChanged()


class QGraphicsScene(PySide6.QtCore.QObject):

    changed                  : typing.ClassVar[Signal] = ... # changed(QList<QRectF>)
    focusItemChanged         : typing.ClassVar[Signal] = ... # focusItemChanged(QGraphicsItem*,QGraphicsItem*,Qt::FocusReason)
    sceneRectChanged         : typing.ClassVar[Signal] = ... # sceneRectChanged(QRectF)
    selectionChanged         : typing.ClassVar[Signal] = ... # selectionChanged()

    class ItemIndexMethod(enum.Enum):

        NoIndex                   = -1
        BspTreeIndex              = 0x0

    class SceneLayer(enum.Flag):

        ItemLayer                 = 0x1
        BackgroundLayer           = 0x2
        ForegroundLayer           = 0x4
        AllLayers                 = 0xffff


class QGraphicsSceneContextMenuEvent(PySide6.QtWidgets.QGraphicsSceneEvent):

    class Reason(enum.Enum):

        Mouse                     = 0x0
        Keyboard                  = 0x1
        Other                     = 0x2


class QGraphicsSceneDragDropEvent(PySide6.QtWidgets.QGraphicsSceneEvent): ...


class QGraphicsSceneEvent(PySide6.QtCore.QEvent): ...
    def __repr__(self, /) -> str: ...


class QGraphicsSceneHelpEvent(PySide6.QtWidgets.QGraphicsSceneEvent): ...


class QGraphicsSceneHoverEvent(PySide6.QtWidgets.QGraphicsSceneEvent): ...


class QGraphicsSceneMouseEvent(PySide6.QtWidgets.QGraphicsSceneEvent): ...


class QGraphicsSceneMoveEvent(PySide6.QtWidgets.QGraphicsSceneEvent): ...


class QGraphicsSceneResizeEvent(PySide6.QtWidgets.QGraphicsSceneEvent): ...


class QGraphicsSceneWheelEvent(PySide6.QtWidgets.QGraphicsSceneEvent): ...


class QGraphicsSimpleTextItem(PySide6.QtWidgets.QAbstractGraphicsShapeItem): ...


class QGraphicsTextItem(PySide6.QtWidgets.QGraphicsObject):

    linkActivated            : typing.ClassVar[Signal] = ... # linkActivated(QString)
    linkHovered              : typing.ClassVar[Signal] = ... # linkHovered(QString)


class QGraphicsTransform(PySide6.QtCore.QObject): ...


class QGraphicsView(PySide6.QtWidgets.QAbstractScrollArea):

    rubberBandChanged        : typing.ClassVar[Signal] = ... # rubberBandChanged(QRect,QPointF,QPointF)

    class CacheModeFlag(enum.Flag):

        CacheNone                 = 0x0
        CacheBackground           = 0x1

    class DragMode(enum.Enum):

        NoDrag                    = 0x0
        ScrollHandDrag            = 0x1
        RubberBandDrag            = 0x2

    class OptimizationFlag(enum.Flag):

        DontSavePainterState      = 0x1
        DontAdjustForAntialiasing = 0x2
        IndirectPainting          = 0x4

    class ViewportAnchor(enum.Enum):

        NoAnchor                  = 0x0
        AnchorViewCenter          = 0x1
        AnchorUnderMouse          = 0x2

    class ViewportUpdateMode(enum.Enum):

        FullViewportUpdate        = 0x0
        MinimalViewportUpdate     = 0x1
        SmartViewportUpdate       = 0x2
        NoViewportUpdate          = 0x3
        BoundingRectViewportUpdate = 0x4


class QGraphicsWidget(PySide6.QtWidgets.QGraphicsObject, PySide6.QtWidgets.QGraphicsLayoutItem):

    geometryChanged          : typing.ClassVar[Signal] = ... # geometryChanged()
    layoutChanged            : typing.ClassVar[Signal] = ... # layoutChanged()


class QGridLayout(PySide6.QtWidgets.QLayout): ...


class QGroupBox(PySide6.QtWidgets.QWidget):

    clicked                  : typing.ClassVar[Signal] = ... # clicked(); clicked(bool)
    toggled                  : typing.ClassVar[Signal] = ... # toggled(bool)


class QHBoxLayout(PySide6.QtWidgets.QBoxLayout): ...


class QHeaderView(PySide6.QtWidgets.QAbstractItemView):

    geometriesChanged        : typing.ClassVar[Signal] = ... # geometriesChanged()
    sectionClicked           : typing.ClassVar[Signal] = ... # sectionClicked(int)
    sectionCountChanged      : typing.ClassVar[Signal] = ... # sectionCountChanged(int,int)
    sectionDoubleClicked     : typing.ClassVar[Signal] = ... # sectionDoubleClicked(int)
    sectionEntered           : typing.ClassVar[Signal] = ... # sectionEntered(int)
    sectionHandleDoubleClicked: typing.ClassVar[Signal] = ... # sectionHandleDoubleClicked(int)
    sectionMoved             : typing.ClassVar[Signal] = ... # sectionMoved(int,int,int)
    sectionPressed           : typing.ClassVar[Signal] = ... # sectionPressed(int)
    sectionResized           : typing.ClassVar[Signal] = ... # sectionResized(int,int,int)
    sortIndicatorChanged     : typing.ClassVar[Signal] = ... # sortIndicatorChanged(int,Qt::SortOrder)
    sortIndicatorClearableChanged: typing.ClassVar[Signal] = ... # sortIndicatorClearableChanged(bool)

    class ResizeMode(enum.Enum):

        Interactive               = 0x0
        Stretch                   = 0x1
        Custom                    = 0x2
        Fixed                     = 0x2
        ResizeToContents          = 0x3


class QInputDialog(PySide6.QtWidgets.QDialog):

    doubleValueChanged       : typing.ClassVar[Signal] = ... # doubleValueChanged(double)
    doubleValueSelected      : typing.ClassVar[Signal] = ... # doubleValueSelected(double)
    intValueChanged          : typing.ClassVar[Signal] = ... # intValueChanged(int)
    intValueSelected         : typing.ClassVar[Signal] = ... # intValueSelected(int)
    textValueChanged         : typing.ClassVar[Signal] = ... # textValueChanged(QString)
    textValueSelected        : typing.ClassVar[Signal] = ... # textValueSelected(QString)

    class InputDialogOption(enum.Enum):

        NoButtons                 = 0x1
        UseListViewForComboBoxItems = 0x2
        UsePlainTextEditForTextInput = 0x4

    class InputMode(enum.Enum):

        TextInput                 = 0x0
        IntInput                  = 0x1
        DoubleInput               = 0x2


class QIntList: ...


class QItemDelegate(PySide6.QtWidgets.QAbstractItemDelegate): ...


class QItemEditorCreatorBase(Shiboken.Object): ...


class QItemEditorFactory(Shiboken.Object): ...


class QKeySequenceEdit(PySide6.QtWidgets.QWidget):

    editingFinished          : typing.ClassVar[Signal] = ... # editingFinished()
    keySequenceChanged       : typing.ClassVar[Signal] = ... # keySequenceChanged(QKeySequence)


class QLCDNumber(PySide6.QtWidgets.QFrame):

    overflow                 : typing.ClassVar[Signal] = ... # overflow()

    class Mode(enum.Enum):

        Hex                       = 0x0
        Dec                       = 0x1
        Oct                       = 0x2
        Bin                       = 0x3

    class SegmentStyle(enum.Enum):

        Outline                   = 0x0
        Filled                    = 0x1
        Flat                      = 0x2


class QLabel(PySide6.QtWidgets.QFrame):

    linkActivated            : typing.ClassVar[Signal] = ... # linkActivated(QString)
    linkHovered              : typing.ClassVar[Signal] = ... # linkHovered(QString)


class QLayout(PySide6.QtCore.QObject, PySide6.QtWidgets.QLayoutItem):

    class SizeConstraint(enum.Enum):

        SetDefaultConstraint      = 0x0
        SetNoConstraint           = 0x1
        SetMinimumSize            = 0x2
        SetFixedSize              = 0x3
        SetMaximumSize            = 0x4
        SetMinAndMaxSize          = 0x5


class QLayoutItem(Shiboken.Object): ...


class QLineEdit(PySide6.QtWidgets.QWidget):

    cursorPositionChanged    : typing.ClassVar[Signal] = ... # cursorPositionChanged(int,int)
    editingFinished          : typing.ClassVar[Signal] = ... # editingFinished()
    inputRejected            : typing.ClassVar[Signal] = ... # inputRejected()
    returnPressed            : typing.ClassVar[Signal] = ... # returnPressed()
    selectionChanged         : typing.ClassVar[Signal] = ... # selectionChanged()
    textChanged              : typing.ClassVar[Signal] = ... # textChanged(QString)
    textEdited               : typing.ClassVar[Signal] = ... # textEdited(QString)

    class ActionPosition(enum.Enum):

        LeadingPosition           = 0x0
        TrailingPosition          = 0x1

    class EchoMode(enum.Enum):

        Normal                    = 0x0
        NoEcho                    = 0x1
        Password                  = 0x2
        PasswordEchoOnEdit        = 0x3


class QListView(PySide6.QtWidgets.QAbstractItemView):

    indexesMoved             : typing.ClassVar[Signal] = ... # indexesMoved(QModelIndexList)

    class Flow(enum.Enum):

        LeftToRight               = 0x0
        TopToBottom               = 0x1

    class LayoutMode(enum.Enum):

        SinglePass                = 0x0
        Batched                   = 0x1

    class Movement(enum.Enum):

        Static                    = 0x0
        Free                      = 0x1
        Snap                      = 0x2

    class ResizeMode(enum.Enum):

        Fixed                     = 0x0
        Adjust                    = 0x1

    class ViewMode(enum.Enum):

        ListMode                  = 0x0
        IconMode                  = 0x1


class QListWidget(PySide6.QtWidgets.QListView):

    currentItemChanged       : typing.ClassVar[Signal] = ... # currentItemChanged(QListWidgetItem*,QListWidgetItem*)
    currentRowChanged        : typing.ClassVar[Signal] = ... # currentRowChanged(int)
    currentTextChanged       : typing.ClassVar[Signal] = ... # currentTextChanged(QString)
    itemActivated            : typing.ClassVar[Signal] = ... # itemActivated(QListWidgetItem*)
    itemChanged              : typing.ClassVar[Signal] = ... # itemChanged(QListWidgetItem*)
    itemClicked              : typing.ClassVar[Signal] = ... # itemClicked(QListWidgetItem*)
    itemDoubleClicked        : typing.ClassVar[Signal] = ... # itemDoubleClicked(QListWidgetItem*)
    itemEntered              : typing.ClassVar[Signal] = ... # itemEntered(QListWidgetItem*)
    itemPressed              : typing.ClassVar[Signal] = ... # itemPressed(QListWidgetItem*)
    itemSelectionChanged     : typing.ClassVar[Signal] = ... # itemSelectionChanged()


class QListWidgetItem(Shiboken.Object):

    class ItemType(enum.IntEnum):

        Type                      = 0x0
        UserType                  = 0x3e8


class QMainWindow(PySide6.QtWidgets.QWidget):

    iconSizeChanged          : typing.ClassVar[Signal] = ... # iconSizeChanged(QSize)
    tabifiedDockWidgetActivated: typing.ClassVar[Signal] = ... # tabifiedDockWidgetActivated(QDockWidget*)
    toolButtonStyleChanged   : typing.ClassVar[Signal] = ... # toolButtonStyleChanged(Qt::ToolButtonStyle)

    class DockOption(enum.Flag):

        AnimatedDocks             = 0x1
        AllowNestedDocks          = 0x2
        AllowTabbedDocks          = 0x4
        ForceTabbedDocks          = 0x8
        VerticalTabs              = 0x10
        GroupedDragging           = 0x20


class QMdiArea(PySide6.QtWidgets.QAbstractScrollArea):

    subWindowActivated       : typing.ClassVar[Signal] = ... # subWindowActivated(QMdiSubWindow*)

    class AreaOption(enum.Flag):

        DontMaximizeSubWindowOnActivation = 0x1

    class ViewMode(enum.Enum):

        SubWindowView             = 0x0
        TabbedView                = 0x1

    class WindowOrder(enum.Enum):

        CreationOrder             = 0x0
        StackingOrder             = 0x1
        ActivationHistoryOrder    = 0x2


class QMdiSubWindow(PySide6.QtWidgets.QWidget):

    aboutToActivate          : typing.ClassVar[Signal] = ... # aboutToActivate()
    windowStateChanged       : typing.ClassVar[Signal] = ... # windowStateChanged(Qt::WindowStates,Qt::WindowStates)

    class SubWindowOption(enum.Flag):

        AllowOutsideAreaHorizontally = 0x1
        AllowOutsideAreaVertically = 0x2
        RubberBandResize          = 0x4
        RubberBandMove            = 0x8


class QMenu(PySide6.QtWidgets.QWidget):

    aboutToHide              : typing.ClassVar[Signal] = ... # aboutToHide()
    aboutToShow              : typing.ClassVar[Signal] = ... # aboutToShow()
    hovered                  : typing.ClassVar[Signal] = ... # hovered(QAction*)
    triggered                : typing.ClassVar[Signal] = ... # triggered(QAction*)


class QMenuBar(PySide6.QtWidgets.QWidget):

    hovered                  : typing.ClassVar[Signal] = ... # hovered(QAction*)
    triggered                : typing.ClassVar[Signal] = ... # triggered(QAction*)


class QMessageBox(PySide6.QtWidgets.QDialog):

    buttonClicked            : typing.ClassVar[Signal] = ... # buttonClicked(QAbstractButton*)

    class ButtonRole(enum.Enum):

        InvalidRole               = -1
        AcceptRole                = 0x0
        RejectRole                = 0x1
        DestructiveRole           = 0x2
        ActionRole                = 0x3
        HelpRole                  = 0x4
        YesRole                   = 0x5
        NoRole                    = 0x6
        ResetRole                 = 0x7
        ApplyRole                 = 0x8
        NRoles                    = 0x9

    class Icon(enum.Enum):

        NoIcon                    = 0x0
        Information               = 0x1
        Warning                   = 0x2
        Critical                  = 0x3
        Question                  = 0x4

    class Option(enum.Flag):

        DontUseNativeDialog       = 0x1

    class StandardButton(enum.IntFlag):

        ButtonMask                = -769
        NoButton                  = 0x0
        Default                   = 0x100
        Escape                    = 0x200
        FlagMask                  = 0x300
        FirstButton               = 0x400
        Ok                        = 0x400
        Save                      = 0x800
        SaveAll                   = 0x1000
        Open                      = 0x2000
        Yes                       = 0x4000
        YesAll                    = 0x8000
        YesToAll                  = 0x8000
        No                        = 0x10000
        NoAll                     = 0x20000
        NoToAll                   = 0x20000
        Abort                     = 0x40000
        Retry                     = 0x80000
        Ignore                    = 0x100000
        Close                     = 0x200000
        Cancel                    = 0x400000
        Discard                   = 0x800000
        Help                      = 0x1000000
        Apply                     = 0x2000000
        Reset                     = 0x4000000
        LastButton                = 0x8000000
        RestoreDefaults           = 0x8000000


class QPanGesture(PySide6.QtWidgets.QGesture): ...


class QPinchGesture(PySide6.QtWidgets.QGesture):

    class ChangeFlag(enum.Flag):

        ScaleFactorChanged        = 0x1
        RotationAngleChanged      = 0x2
        CenterPointChanged        = 0x4


class QPlainTextDocumentLayout(PySide6.QtGui.QAbstractTextDocumentLayout): ...


class QPlainTextEdit(PySide6.QtWidgets.QAbstractScrollArea):

    blockCountChanged        : typing.ClassVar[Signal] = ... # blockCountChanged(int)
    copyAvailable            : typing.ClassVar[Signal] = ... # copyAvailable(bool)
    cursorPositionChanged    : typing.ClassVar[Signal] = ... # cursorPositionChanged()
    modificationChanged      : typing.ClassVar[Signal] = ... # modificationChanged(bool)
    redoAvailable            : typing.ClassVar[Signal] = ... # redoAvailable(bool)
    selectionChanged         : typing.ClassVar[Signal] = ... # selectionChanged()
    textChanged              : typing.ClassVar[Signal] = ... # textChanged()
    undoAvailable            : typing.ClassVar[Signal] = ... # undoAvailable(bool)
    updateRequest            : typing.ClassVar[Signal] = ... # updateRequest(QRect,int)

    class LineWrapMode(enum.Enum):

        NoWrap                    = 0x0
        WidgetWidth               = 0x1


class QProgressBar(PySide6.QtWidgets.QWidget):

    valueChanged             : typing.ClassVar[Signal] = ... # valueChanged(int)

    class Direction(enum.Enum):

        TopToBottom               = 0x0
        BottomToTop               = 0x1


class QProgressDialog(PySide6.QtWidgets.QDialog):

    canceled                 : typing.ClassVar[Signal] = ... # canceled()


class QProxyStyle(PySide6.QtWidgets.QCommonStyle): ...


class QPushButton(PySide6.QtWidgets.QAbstractButton): ...


class QRadioButton(PySide6.QtWidgets.QAbstractButton): ...


class QRhiWidget(PySide6.QtWidgets.QWidget):

    colorBufferFormatChanged : typing.ClassVar[Signal] = ... # colorBufferFormatChanged(TextureFormat)
    fixedColorBufferSizeChanged: typing.ClassVar[Signal] = ... # fixedColorBufferSizeChanged(QSize)
    frameSubmitted           : typing.ClassVar[Signal] = ... # frameSubmitted()
    mirrorVerticallyChanged  : typing.ClassVar[Signal] = ... # mirrorVerticallyChanged(bool)
    renderFailed             : typing.ClassVar[Signal] = ... # renderFailed()
    sampleCountChanged       : typing.ClassVar[Signal] = ... # sampleCountChanged(int)

    class Api(enum.Enum):

        Null                      = 0x0
        OpenGL                    = 0x1
        Metal                     = 0x2
        Vulkan                    = 0x3
        Direct3D11                = 0x4
        Direct3D12                = 0x5

    class TextureFormat(enum.Enum):

        RGBA8                     = 0x0
        RGBA16F                   = 0x1
        RGBA32F                   = 0x2
        RGB10A2                   = 0x3


class QRubberBand(PySide6.QtWidgets.QWidget):

    class Shape(enum.Enum):

        Line                      = 0x0
        Rectangle                 = 0x1


class QScrollArea(PySide6.QtWidgets.QAbstractScrollArea): ...


class QScrollBar(PySide6.QtWidgets.QAbstractSlider): ...


class QScroller(PySide6.QtCore.QObject):

    scrollerPropertiesChanged: typing.ClassVar[Signal] = ... # scrollerPropertiesChanged(QScrollerProperties)
    stateChanged             : typing.ClassVar[Signal] = ... # stateChanged(QScroller::State)

    class Input(enum.Enum):

        InputPress                = 0x1
        InputMove                 = 0x2
        InputRelease              = 0x3

    class ScrollerGestureType(enum.Enum):

        TouchGesture              = 0x0
        LeftMouseButtonGesture    = 0x1
        RightMouseButtonGesture   = 0x2
        MiddleMouseButtonGesture  = 0x3

    class State(enum.Enum):

        Inactive                  = 0x0
        Pressed                   = 0x1
        Dragging                  = 0x2
        Scrolling                 = 0x3


class QScrollerProperties(Shiboken.Object):

    class FrameRates(enum.Enum):

        Standard                  = 0x0
        Fps60                     = 0x1
        Fps30                     = 0x2
        Fps20                     = 0x3

    class OvershootPolicy(enum.Enum):

        OvershootWhenScrollable   = 0x0
        OvershootAlwaysOff        = 0x1
        OvershootAlwaysOn         = 0x2

    class ScrollMetric(enum.Enum):

        MousePressEventDelay      = 0x0
        DragStartDistance         = 0x1
        DragVelocitySmoothingFactor = 0x2
        AxisLockThreshold         = 0x3
        ScrollingCurve            = 0x4
        DecelerationFactor        = 0x5
        MinimumVelocity           = 0x6
        MaximumVelocity           = 0x7
        MaximumClickThroughVelocity = 0x8
        AcceleratingFlickMaximumTime = 0x9
        AcceleratingFlickSpeedupFactor = 0xa
        SnapPositionRatio         = 0xb
        SnapTime                  = 0xc
        OvershootDragResistanceFactor = 0xd
        OvershootDragDistanceFactor = 0xe
        OvershootScrollDistanceFactor = 0xf
        OvershootScrollTime       = 0x10
        HorizontalOvershootPolicy = 0x11
        VerticalOvershootPolicy   = 0x12
        FrameRate                 = 0x13
        ScrollMetricCount         = 0x14


class QSizeGrip(PySide6.QtWidgets.QWidget): ...


class QSizePolicy(Shiboken.Object):

    class ControlType(enum.Flag):

        DefaultType               = 0x1
        ButtonBox                 = 0x2
        CheckBox                  = 0x4
        ComboBox                  = 0x8
        Frame                     = 0x10
        GroupBox                  = 0x20
        Label                     = 0x40
        Line                      = 0x80
        LineEdit                  = 0x100
        PushButton                = 0x200
        RadioButton               = 0x400
        Slider                    = 0x800
        SpinBox                   = 0x1000
        TabWidget                 = 0x2000
        ToolButton                = 0x4000

    class Policy(enum.Enum):

        Fixed                     = 0x0
        Minimum                   = 0x1
        MinimumExpanding          = 0x3
        Maximum                   = 0x4
        Preferred                 = 0x5
        Expanding                 = 0x7
        Ignored                   = 0xd

    class PolicyFlag(enum.IntFlag):

        GrowFlag                  = 0x1
        ExpandFlag                = 0x2
        ShrinkFlag                = 0x4
        IgnoreFlag                = 0x8


    def __repr__(self, /) -> str: ...


class QSlider(PySide6.QtWidgets.QAbstractSlider):

    class TickPosition(enum.Enum):

        NoTicks                   = 0x0
        TicksAbove                = 0x1
        TicksLeft                 = 0x1
        TicksBelow                = 0x2
        TicksRight                = 0x2
        TicksBothSides            = 0x3


class QSpacerItem(PySide6.QtWidgets.QLayoutItem): ...


class QSpinBox(PySide6.QtWidgets.QAbstractSpinBox):

    textChanged              : typing.ClassVar[Signal] = ... # textChanged(QString)
    valueChanged             : typing.ClassVar[Signal] = ... # valueChanged(int)


class QSplashScreen(PySide6.QtWidgets.QWidget):

    messageChanged           : typing.ClassVar[Signal] = ... # messageChanged(QString)


class QSplitter(PySide6.QtWidgets.QFrame):

    splitterMoved            : typing.ClassVar[Signal] = ... # splitterMoved(int,int)


class QSplitterHandle(PySide6.QtWidgets.QWidget): ...


class QStackedLayout(PySide6.QtWidgets.QLayout):

    currentChanged           : typing.ClassVar[Signal] = ... # currentChanged(int)
    widgetAdded              : typing.ClassVar[Signal] = ... # widgetAdded(int)
    widgetRemoved            : typing.ClassVar[Signal] = ... # widgetRemoved(int)

    class StackingMode(enum.Enum):

        StackOne                  = 0x0
        StackAll                  = 0x1


class QStackedWidget(PySide6.QtWidgets.QFrame):

    currentChanged           : typing.ClassVar[Signal] = ... # currentChanged(int)
    widgetAdded              : typing.ClassVar[Signal] = ... # widgetAdded(int)
    widgetRemoved            : typing.ClassVar[Signal] = ... # widgetRemoved(int)


class QStatusBar(PySide6.QtWidgets.QWidget):

    messageChanged           : typing.ClassVar[Signal] = ... # messageChanged(QString)


class QStyle(PySide6.QtCore.QObject):

    class ComplexControl(enum.IntEnum):

        CC_SpinBox                = 0x0
        CC_ComboBox               = 0x1
        CC_ScrollBar              = 0x2
        CC_Slider                 = 0x3
        CC_ToolButton             = 0x4
        CC_TitleBar               = 0x5
        CC_Dial                   = 0x6
        CC_GroupBox               = 0x7
        CC_MdiControls            = 0x8
        CC_CustomBase             = 0xf0000000

    class ContentsType(enum.IntEnum):

        CT_PushButton             = 0x0
        CT_CheckBox               = 0x1
        CT_RadioButton            = 0x2
        CT_ToolButton             = 0x3
        CT_ComboBox               = 0x4
        CT_Splitter               = 0x5
        CT_ProgressBar            = 0x6
        CT_MenuItem               = 0x7
        CT_MenuBarItem            = 0x8
        CT_MenuBar                = 0x9
        CT_Menu                   = 0xa
        CT_TabBarTab              = 0xb
        CT_Slider                 = 0xc
        CT_ScrollBar              = 0xd
        CT_LineEdit               = 0xe
        CT_SpinBox                = 0xf
        CT_SizeGrip               = 0x10
        CT_TabWidget              = 0x11
        CT_DialogButtons          = 0x12
        CT_HeaderSection          = 0x13
        CT_GroupBox               = 0x14
        CT_MdiControls            = 0x15
        CT_ItemViewItem           = 0x16
        CT_CustomBase             = 0xf0000000

    class ControlElement(enum.IntEnum):

        CE_PushButton             = 0x0
        CE_PushButtonBevel        = 0x1
        CE_PushButtonLabel        = 0x2
        CE_CheckBox               = 0x3
        CE_CheckBoxLabel          = 0x4
        CE_RadioButton            = 0x5
        CE_RadioButtonLabel       = 0x6
        CE_TabBarTab              = 0x7
        CE_TabBarTabShape         = 0x8
        CE_TabBarTabLabel         = 0x9
        CE_ProgressBar            = 0xa
        CE_ProgressBarGroove      = 0xb
        CE_ProgressBarContents    = 0xc
        CE_ProgressBarLabel       = 0xd
        CE_MenuItem               = 0xe
        CE_MenuScroller           = 0xf
        CE_MenuVMargin            = 0x10
        CE_MenuHMargin            = 0x11
        CE_MenuTearoff            = 0x12
        CE_MenuEmptyArea          = 0x13
        CE_MenuBarItem            = 0x14
        CE_MenuBarEmptyArea       = 0x15
        CE_ToolButtonLabel        = 0x16
        CE_Header                 = 0x17
        CE_HeaderSection          = 0x18
        CE_HeaderLabel            = 0x19
        CE_ToolBoxTab             = 0x1a
        CE_SizeGrip               = 0x1b
        CE_Splitter               = 0x1c
        CE_RubberBand             = 0x1d
        CE_DockWidgetTitle        = 0x1e
        CE_ScrollBarAddLine       = 0x1f
        CE_ScrollBarSubLine       = 0x20
        CE_ScrollBarAddPage       = 0x21
        CE_ScrollBarSubPage       = 0x22
        CE_ScrollBarSlider        = 0x23
        CE_ScrollBarFirst         = 0x24
        CE_ScrollBarLast          = 0x25
        CE_FocusFrame             = 0x26
        CE_ComboBoxLabel          = 0x27
        CE_ToolBar                = 0x28
        CE_ToolBoxTabShape        = 0x29
        CE_ToolBoxTabLabel        = 0x2a
        CE_HeaderEmptyArea        = 0x2b
        CE_ColumnViewGrip         = 0x2c
        CE_ItemViewItem           = 0x2d
        CE_ShapedFrame            = 0x2e
        CE_CustomBase             = 0xf0000000

    class PixelMetric(enum.IntEnum):

        PM_ButtonMargin           = 0x0
        PM_ButtonDefaultIndicator = 0x1
        PM_MenuButtonIndicator    = 0x2
        PM_ButtonShiftHorizontal  = 0x3
        PM_ButtonShiftVertical    = 0x4
        PM_DefaultFrameWidth      = 0x5
        PM_SpinBoxFrameWidth      = 0x6
        PM_ComboBoxFrameWidth     = 0x7
        PM_MaximumDragDistance    = 0x8
        PM_ScrollBarExtent        = 0x9
        PM_ScrollBarSliderMin     = 0xa
        PM_SliderThickness        = 0xb
        PM_SliderControlThickness = 0xc
        PM_SliderLength           = 0xd
        PM_SliderTickmarkOffset   = 0xe
        PM_SliderSpaceAvailable   = 0xf
        PM_DockWidgetSeparatorExtent = 0x10
        PM_DockWidgetHandleExtent = 0x11
        PM_DockWidgetFrameWidth   = 0x12
        PM_TabBarTabOverlap       = 0x13
        PM_TabBarTabHSpace        = 0x14
        PM_TabBarTabVSpace        = 0x15
        PM_TabBarBaseHeight       = 0x16
        PM_TabBarBaseOverlap      = 0x17
        PM_ProgressBarChunkWidth  = 0x18
        PM_SplitterWidth          = 0x19
        PM_TitleBarHeight         = 0x1a
        PM_MenuScrollerHeight     = 0x1b
        PM_MenuHMargin            = 0x1c
        PM_MenuVMargin            = 0x1d
        PM_MenuPanelWidth         = 0x1e
        PM_MenuTearoffHeight      = 0x1f
        PM_MenuDesktopFrameWidth  = 0x20
        PM_MenuBarPanelWidth      = 0x21
        PM_MenuBarItemSpacing     = 0x22
        PM_MenuBarVMargin         = 0x23
        PM_MenuBarHMargin         = 0x24
        PM_IndicatorWidth         = 0x25
        PM_IndicatorHeight        = 0x26
        PM_ExclusiveIndicatorWidth = 0x27
        PM_ExclusiveIndicatorHeight = 0x28
        PM_DialogButtonsSeparator = 0x29
        PM_DialogButtonsButtonWidth = 0x2a
        PM_DialogButtonsButtonHeight = 0x2b
        PM_MdiSubWindowFrameWidth = 0x2c
        PM_MdiSubWindowMinimizedWidth = 0x2d
        PM_HeaderMargin           = 0x2e
        PM_HeaderMarkSize         = 0x2f
        PM_HeaderGripMargin       = 0x30
        PM_TabBarTabShiftHorizontal = 0x31
        PM_TabBarTabShiftVertical = 0x32
        PM_TabBarScrollButtonWidth = 0x33
        PM_ToolBarFrameWidth      = 0x34
        PM_ToolBarHandleExtent    = 0x35
        PM_ToolBarItemSpacing     = 0x36
        PM_ToolBarItemMargin      = 0x37
        PM_ToolBarSeparatorExtent = 0x38
        PM_ToolBarExtensionExtent = 0x39
        PM_SpinBoxSliderHeight    = 0x3a
        PM_ToolBarIconSize        = 0x3b
        PM_ListViewIconSize       = 0x3c
        PM_IconViewIconSize       = 0x3d
        PM_SmallIconSize          = 0x3e
        PM_LargeIconSize          = 0x3f
        PM_FocusFrameVMargin      = 0x40
        PM_FocusFrameHMargin      = 0x41
        PM_ToolTipLabelFrameWidth = 0x42
        PM_CheckBoxLabelSpacing   = 0x43
        PM_TabBarIconSize         = 0x44
        PM_SizeGripSize           = 0x45
        PM_DockWidgetTitleMargin  = 0x46
        PM_MessageBoxIconSize     = 0x47
        PM_ButtonIconSize         = 0x48
        PM_DockWidgetTitleBarButtonMargin = 0x49
        PM_RadioButtonLabelSpacing = 0x4a
        PM_LayoutLeftMargin       = 0x4b
        PM_LayoutTopMargin        = 0x4c
        PM_LayoutRightMargin      = 0x4d
        PM_LayoutBottomMargin     = 0x4e
        PM_LayoutHorizontalSpacing = 0x4f
        PM_LayoutVerticalSpacing  = 0x50
        PM_TabBar_ScrollButtonOverlap = 0x51
        PM_TextCursorWidth        = 0x52
        PM_TabCloseIndicatorWidth = 0x53
        PM_TabCloseIndicatorHeight = 0x54
        PM_ScrollView_ScrollBarSpacing = 0x55
        PM_ScrollView_ScrollBarOverlap = 0x56
        PM_SubMenuOverlap         = 0x57
        PM_TreeViewIndentation    = 0x58
        PM_HeaderDefaultSectionSizeHorizontal = 0x59
        PM_HeaderDefaultSectionSizeVertical = 0x5a
        PM_TitleBarButtonIconSize = 0x5b
        PM_TitleBarButtonSize     = 0x5c
        PM_LineEditIconSize       = 0x5d
        PM_LineEditIconMargin     = 0x5e
        PM_CustomBase             = 0xf0000000

    class PrimitiveElement(enum.IntEnum):

        PE_Frame                  = 0x0
        PE_FrameDefaultButton     = 0x1
        PE_FrameDockWidget        = 0x2
        PE_FrameFocusRect         = 0x3
        PE_FrameGroupBox          = 0x4
        PE_FrameLineEdit          = 0x5
        PE_FrameMenu              = 0x6
        PE_FrameStatusBarItem     = 0x7
        PE_FrameTabWidget         = 0x8
        PE_FrameWindow            = 0x9
        PE_FrameButtonBevel       = 0xa
        PE_FrameButtonTool        = 0xb
        PE_FrameTabBarBase        = 0xc
        PE_PanelButtonCommand     = 0xd
        PE_PanelButtonBevel       = 0xe
        PE_PanelButtonTool        = 0xf
        PE_PanelMenuBar           = 0x10
        PE_PanelToolBar           = 0x11
        PE_PanelLineEdit          = 0x12
        PE_IndicatorArrowDown     = 0x13
        PE_IndicatorArrowLeft     = 0x14
        PE_IndicatorArrowRight    = 0x15
        PE_IndicatorArrowUp       = 0x16
        PE_IndicatorBranch        = 0x17
        PE_IndicatorButtonDropDown = 0x18
        PE_IndicatorItemViewItemCheck = 0x19
        PE_IndicatorCheckBox      = 0x1a
        PE_IndicatorDockWidgetResizeHandle = 0x1b
        PE_IndicatorHeaderArrow   = 0x1c
        PE_IndicatorMenuCheckMark = 0x1d
        PE_IndicatorProgressChunk = 0x1e
        PE_IndicatorRadioButton   = 0x1f
        PE_IndicatorSpinDown      = 0x20
        PE_IndicatorSpinMinus     = 0x21
        PE_IndicatorSpinPlus      = 0x22
        PE_IndicatorSpinUp        = 0x23
        PE_IndicatorToolBarHandle = 0x24
        PE_IndicatorToolBarSeparator = 0x25
        PE_PanelTipLabel          = 0x26
        PE_IndicatorTabTear       = 0x27
        PE_IndicatorTabTearLeft   = 0x27
        PE_PanelScrollAreaCorner  = 0x28
        PE_Widget                 = 0x29
        PE_IndicatorColumnViewArrow = 0x2a
        PE_IndicatorItemViewItemDrop = 0x2b
        PE_PanelItemViewItem      = 0x2c
        PE_PanelItemViewRow       = 0x2d
        PE_PanelStatusBar         = 0x2e
        PE_IndicatorTabClose      = 0x2f
        PE_PanelMenu              = 0x30
        PE_IndicatorTabTearRight  = 0x31
        PE_CustomBase             = 0xf000000

    class RequestSoftwareInputPanel(enum.Enum):

        RSIP_OnMouseClickAndAlreadyFocused = 0x0
        RSIP_OnMouseClick         = 0x1

    class StandardPixmap(enum.IntEnum):

        SP_TitleBarMenuButton     = 0x0
        SP_TitleBarMinButton      = 0x1
        SP_TitleBarMaxButton      = 0x2
        SP_TitleBarCloseButton    = 0x3
        SP_TitleBarNormalButton   = 0x4
        SP_TitleBarShadeButton    = 0x5
        SP_TitleBarUnshadeButton  = 0x6
        SP_TitleBarContextHelpButton = 0x7
        SP_DockWidgetCloseButton  = 0x8
        SP_MessageBoxInformation  = 0x9
        SP_MessageBoxWarning      = 0xa
        SP_MessageBoxCritical     = 0xb
        SP_MessageBoxQuestion     = 0xc
        SP_DesktopIcon            = 0xd
        SP_TrashIcon              = 0xe
        SP_ComputerIcon           = 0xf
        SP_DriveFDIcon            = 0x10
        SP_DriveHDIcon            = 0x11
        SP_DriveCDIcon            = 0x12
        SP_DriveDVDIcon           = 0x13
        SP_DriveNetIcon           = 0x14
        SP_DirOpenIcon            = 0x15
        SP_DirClosedIcon          = 0x16
        SP_DirLinkIcon            = 0x17
        SP_DirLinkOpenIcon        = 0x18
        SP_FileIcon               = 0x19
        SP_FileLinkIcon           = 0x1a
        SP_ToolBarHorizontalExtensionButton = 0x1b
        SP_ToolBarVerticalExtensionButton = 0x1c
        SP_FileDialogStart        = 0x1d
        SP_FileDialogEnd          = 0x1e
        SP_FileDialogToParent     = 0x1f
        SP_FileDialogNewFolder    = 0x20
        SP_FileDialogDetailedView = 0x21
        SP_FileDialogInfoView     = 0x22
        SP_FileDialogContentsView = 0x23
        SP_FileDialogListView     = 0x24
        SP_FileDialogBack         = 0x25
        SP_DirIcon                = 0x26
        SP_DialogOkButton         = 0x27
        SP_DialogCancelButton     = 0x28
        SP_DialogHelpButton       = 0x29
        SP_DialogOpenButton       = 0x2a
        SP_DialogSaveButton       = 0x2b
        SP_DialogCloseButton      = 0x2c
        SP_DialogApplyButton      = 0x2d
        SP_DialogResetButton      = 0x2e
        SP_DialogDiscardButton    = 0x2f
        SP_DialogYesButton        = 0x30
        SP_DialogNoButton         = 0x31
        SP_ArrowUp                = 0x32
        SP_ArrowDown              = 0x33
        SP_ArrowLeft              = 0x34
        SP_ArrowRight             = 0x35
        SP_ArrowBack              = 0x36
        SP_ArrowForward           = 0x37
        SP_DirHomeIcon            = 0x38
        SP_CommandLink            = 0x39
        SP_VistaShield            = 0x3a
        SP_BrowserReload          = 0x3b
        SP_BrowserStop            = 0x3c
        SP_MediaPlay              = 0x3d
        SP_MediaStop              = 0x3e
        SP_MediaPause             = 0x3f
        SP_MediaSkipForward       = 0x40
        SP_MediaSkipBackward      = 0x41
        SP_MediaSeekForward       = 0x42
        SP_MediaSeekBackward      = 0x43
        SP_MediaVolume            = 0x44
        SP_MediaVolumeMuted       = 0x45
        SP_LineEditClearButton    = 0x46
        SP_DialogYesToAllButton   = 0x47
        SP_DialogNoToAllButton    = 0x48
        SP_DialogSaveAllButton    = 0x49
        SP_DialogAbortButton      = 0x4a
        SP_DialogRetryButton      = 0x4b
        SP_DialogIgnoreButton     = 0x4c
        SP_RestoreDefaultsButton  = 0x4d
        SP_TabCloseButton         = 0x4e
        NStandardPixmap           = 0x4f
        SP_CustomBase             = 0xf0000000

    class StateFlag(enum.Flag):

        State_None                = 0x0
        State_Enabled             = 0x1
        State_Raised              = 0x2
        State_Sunken              = 0x4
        State_Off                 = 0x8
        State_NoChange            = 0x10
        State_On                  = 0x20
        State_DownArrow           = 0x40
        State_Horizontal          = 0x80
        State_HasFocus            = 0x100
        State_Top                 = 0x200
        State_Bottom              = 0x400
        State_FocusAtBorder       = 0x800
        State_AutoRaise           = 0x1000
        State_MouseOver           = 0x2000
        State_UpArrow             = 0x4000
        State_Selected            = 0x8000
        State_Active              = 0x10000
        State_Window              = 0x20000
        State_Open                = 0x40000
        State_Children            = 0x80000
        State_Item                = 0x100000
        State_Sibling             = 0x200000
        State_Editing             = 0x400000
        State_KeyboardFocusChange = 0x800000
        State_ReadOnly            = 0x2000000
        State_Small               = 0x4000000
        State_Mini                = 0x8000000

    class StyleHint(enum.IntEnum):

        SH_EtchDisabledText       = 0x0
        SH_DitherDisabledText     = 0x1
        SH_ScrollBar_MiddleClickAbsolutePosition = 0x2
        SH_ScrollBar_ScrollWhenPointerLeavesControl = 0x3
        SH_TabBar_SelectMouseType = 0x4
        SH_TabBar_Alignment       = 0x5
        SH_Header_ArrowAlignment  = 0x6
        SH_Slider_SnapToValue     = 0x7
        SH_Slider_SloppyKeyEvents = 0x8
        SH_ProgressDialog_CenterCancelButton = 0x9
        SH_ProgressDialog_TextLabelAlignment = 0xa
        SH_PrintDialog_RightAlignButtons = 0xb
        SH_MainWindow_SpaceBelowMenuBar = 0xc
        SH_FontDialog_SelectAssociatedText = 0xd
        SH_Menu_AllowActiveAndDisabled = 0xe
        SH_Menu_SpaceActivatesItem = 0xf
        SH_Menu_SubMenuPopupDelay = 0x10
        SH_ScrollView_FrameOnlyAroundContents = 0x11
        SH_MenuBar_AltKeyNavigation = 0x12
        SH_ComboBox_ListMouseTracking = 0x13
        SH_Menu_MouseTracking     = 0x14
        SH_MenuBar_MouseTracking  = 0x15
        SH_ItemView_ChangeHighlightOnFocus = 0x16
        SH_Widget_ShareActivation = 0x17
        SH_Workspace_FillSpaceOnMaximize = 0x18
        SH_ComboBox_Popup         = 0x19
        SH_TitleBar_NoBorder      = 0x1a
        SH_Slider_StopMouseOverSlider = 0x1b
        SH_BlinkCursorWhenTextSelected = 0x1c
        SH_RichText_FullWidthSelection = 0x1d
        SH_Menu_Scrollable        = 0x1e
        SH_GroupBox_TextLabelVerticalAlignment = 0x1f
        SH_GroupBox_TextLabelColor = 0x20
        SH_Menu_SloppySubMenus    = 0x21
        SH_Table_GridLineColor    = 0x22
        SH_LineEdit_PasswordCharacter = 0x23
        SH_DialogButtons_DefaultButton = 0x24
        SH_ToolBox_SelectedPageTitleBold = 0x25
        SH_TabBar_PreferNoArrows  = 0x26
        SH_ScrollBar_LeftClickAbsolutePosition = 0x27
        SH_ListViewExpand_SelectMouseType = 0x28
        SH_UnderlineShortcut      = 0x29
        SH_SpinBox_AnimateButton  = 0x2a
        SH_SpinBox_KeyPressAutoRepeatRate = 0x2b
        SH_SpinBox_ClickAutoRepeatRate = 0x2c
        SH_Menu_FillScreenWithScroll = 0x2d
        SH_ToolTipLabel_Opacity   = 0x2e
        SH_DrawMenuBarSeparator   = 0x2f
        SH_TitleBar_ModifyNotification = 0x30
        SH_Button_FocusPolicy     = 0x31
        SH_MessageBox_UseBorderForButtonSpacing = 0x32
        SH_TitleBar_AutoRaise     = 0x33
        SH_ToolButton_PopupDelay  = 0x34
        SH_FocusFrame_Mask        = 0x35
        SH_RubberBand_Mask        = 0x36
        SH_WindowFrame_Mask       = 0x37
        SH_SpinControls_DisableOnBounds = 0x38
        SH_Dial_BackgroundRole    = 0x39
        SH_ComboBox_LayoutDirection = 0x3a
        SH_ItemView_EllipsisLocation = 0x3b
        SH_ItemView_ShowDecorationSelected = 0x3c
        SH_ItemView_ActivateItemOnSingleClick = 0x3d
        SH_ScrollBar_ContextMenu  = 0x3e
        SH_ScrollBar_RollBetweenButtons = 0x3f
        SH_Slider_AbsoluteSetButtons = 0x40
        SH_Slider_PageSetButtons  = 0x41
        SH_Menu_KeyboardSearch    = 0x42
        SH_TabBar_ElideMode       = 0x43
        SH_DialogButtonLayout     = 0x44
        SH_ComboBox_PopupFrameStyle = 0x45
        SH_MessageBox_TextInteractionFlags = 0x46
        SH_DialogButtonBox_ButtonsHaveIcons = 0x47
        SH_MessageBox_CenterButtons = 0x48
        SH_Menu_SelectionWrap     = 0x49
        SH_ItemView_MovementWithoutUpdatingSelection = 0x4a
        SH_ToolTip_Mask           = 0x4b
        SH_FocusFrame_AboveWidget = 0x4c
        SH_TextControl_FocusIndicatorTextCharFormat = 0x4d
        SH_WizardStyle            = 0x4e
        SH_ItemView_ArrowKeysNavigateIntoChildren = 0x4f
        SH_Menu_Mask              = 0x50
        SH_Menu_FlashTriggeredItem = 0x51
        SH_Menu_FadeOutOnHide     = 0x52
        SH_SpinBox_ClickAutoRepeatThreshold = 0x53
        SH_ItemView_PaintAlternatingRowColorsForEmptyArea = 0x54
        SH_FormLayoutWrapPolicy   = 0x55
        SH_TabWidget_DefaultTabPosition = 0x56
        SH_ToolBar_Movable        = 0x57
        SH_FormLayoutFieldGrowthPolicy = 0x58
        SH_FormLayoutFormAlignment = 0x59
        SH_FormLayoutLabelAlignment = 0x5a
        SH_ItemView_DrawDelegateFrame = 0x5b
        SH_TabBar_CloseButtonPosition = 0x5c
        SH_DockWidget_ButtonsHaveFrame = 0x5d
        SH_ToolButtonStyle        = 0x5e
        SH_RequestSoftwareInputPanel = 0x5f
        SH_ScrollBar_Transient    = 0x60
        SH_Menu_SupportsSections  = 0x61
        SH_ToolTip_WakeUpDelay    = 0x62
        SH_ToolTip_FallAsleepDelay = 0x63
        SH_Widget_Animate         = 0x64
        SH_Splitter_OpaqueResize  = 0x65
        SH_ComboBox_UseNativePopup = 0x66
        SH_LineEdit_PasswordMaskDelay = 0x67
        SH_TabBar_ChangeCurrentDelay = 0x68
        SH_Menu_SubMenuUniDirection = 0x69
        SH_Menu_SubMenuUniDirectionFailCount = 0x6a
        SH_Menu_SubMenuSloppySelectOtherActions = 0x6b
        SH_Menu_SubMenuSloppyCloseTimeout = 0x6c
        SH_Menu_SubMenuResetWhenReenteringParent = 0x6d
        SH_Menu_SubMenuDontStartSloppyOnLeave = 0x6e
        SH_ItemView_ScrollMode    = 0x6f
        SH_TitleBar_ShowToolTipsOnButtons = 0x70
        SH_Widget_Animation_Duration = 0x71
        SH_ComboBox_AllowWheelScrolling = 0x72
        SH_SpinBox_ButtonsInsideFrame = 0x73
        SH_SpinBox_StepModifier   = 0x74
        SH_TabBar_AllowWheelScrolling = 0x75
        SH_Table_AlwaysDrawLeftTopGridLines = 0x76
        SH_SpinBox_SelectOnStep   = 0x77
        SH_CustomBase             = 0xf0000000

    class SubControl(enum.Flag):

        SC_None                   = 0x0
        SC_ComboBoxFrame          = 0x1
        SC_DialGroove             = 0x1
        SC_GroupBoxCheckBox       = 0x1
        SC_MdiMinButton           = 0x1
        SC_ScrollBarAddLine       = 0x1
        SC_SliderGroove           = 0x1
        SC_SpinBoxUp              = 0x1
        SC_TitleBarSysMenu        = 0x1
        SC_ToolButton             = 0x1
        SC_ComboBoxEditField      = 0x2
        SC_DialHandle             = 0x2
        SC_GroupBoxLabel          = 0x2
        SC_MdiNormalButton        = 0x2
        SC_ScrollBarSubLine       = 0x2
        SC_SliderHandle           = 0x2
        SC_SpinBoxDown            = 0x2
        SC_TitleBarMinButton      = 0x2
        SC_ToolButtonMenu         = 0x2
        SC_ComboBoxArrow          = 0x4
        SC_DialTickmarks          = 0x4
        SC_GroupBoxContents       = 0x4
        SC_MdiCloseButton         = 0x4
        SC_ScrollBarAddPage       = 0x4
        SC_SliderTickmarks        = 0x4
        SC_SpinBoxFrame           = 0x4
        SC_TitleBarMaxButton      = 0x4
        SC_ComboBoxListBoxPopup   = 0x8
        SC_GroupBoxFrame          = 0x8
        SC_ScrollBarSubPage       = 0x8
        SC_SpinBoxEditField       = 0x8
        SC_TitleBarCloseButton    = 0x8
        SC_ScrollBarFirst         = 0x10
        SC_TitleBarNormalButton   = 0x10
        SC_ScrollBarLast          = 0x20
        SC_TitleBarShadeButton    = 0x20
        SC_ScrollBarSlider        = 0x40
        SC_TitleBarUnshadeButton  = 0x40
        SC_ScrollBarGroove        = 0x80
        SC_TitleBarContextHelpButton = 0x80
        SC_TitleBarLabel          = 0x100
        SC_CustomBase             = 0xf0000000
        SC_All                    = 0xffffffff

    class SubElement(enum.IntEnum):

        SE_PushButtonContents     = 0x0
        SE_PushButtonFocusRect    = 0x1
        SE_CheckBoxIndicator      = 0x2
        SE_CheckBoxContents       = 0x3
        SE_CheckBoxFocusRect      = 0x4
        SE_CheckBoxClickRect      = 0x5
        SE_RadioButtonIndicator   = 0x6
        SE_RadioButtonContents    = 0x7
        SE_RadioButtonFocusRect   = 0x8
        SE_RadioButtonClickRect   = 0x9
        SE_ComboBoxFocusRect      = 0xa
        SE_SliderFocusRect        = 0xb
        SE_ProgressBarGroove      = 0xc
        SE_ProgressBarContents    = 0xd
        SE_ProgressBarLabel       = 0xe
        SE_ToolBoxTabContents     = 0xf
        SE_HeaderLabel            = 0x10
        SE_HeaderArrow            = 0x11
        SE_TabWidgetTabBar        = 0x12
        SE_TabWidgetTabPane       = 0x13
        SE_TabWidgetTabContents   = 0x14
        SE_TabWidgetLeftCorner    = 0x15
        SE_TabWidgetRightCorner   = 0x16
        SE_ItemViewItemCheckIndicator = 0x17
        SE_TabBarTearIndicator    = 0x18
        SE_TabBarTearIndicatorLeft = 0x18
        SE_TreeViewDisclosureItem = 0x19
        SE_LineEditContents       = 0x1a
        SE_FrameContents          = 0x1b
        SE_DockWidgetCloseButton  = 0x1c
        SE_DockWidgetFloatButton  = 0x1d
        SE_DockWidgetTitleBarText = 0x1e
        SE_DockWidgetIcon         = 0x1f
        SE_CheckBoxLayoutItem     = 0x20
        SE_ComboBoxLayoutItem     = 0x21
        SE_DateTimeEditLayoutItem = 0x22
        SE_LabelLayoutItem        = 0x23
        SE_ProgressBarLayoutItem  = 0x24
        SE_PushButtonLayoutItem   = 0x25
        SE_RadioButtonLayoutItem  = 0x26
        SE_SliderLayoutItem       = 0x27
        SE_SpinBoxLayoutItem      = 0x28
        SE_ToolButtonLayoutItem   = 0x29
        SE_FrameLayoutItem        = 0x2a
        SE_GroupBoxLayoutItem     = 0x2b
        SE_TabWidgetLayoutItem    = 0x2c
        SE_ItemViewItemDecoration = 0x2d
        SE_ItemViewItemText       = 0x2e
        SE_ItemViewItemFocusRect  = 0x2f
        SE_TabBarTabLeftButton    = 0x30
        SE_TabBarTabRightButton   = 0x31
        SE_TabBarTabText          = 0x32
        SE_ShapedFrameContents    = 0x33
        SE_ToolBarHandle          = 0x34
        SE_TabBarScrollLeftButton = 0x35
        SE_TabBarScrollRightButton = 0x36
        SE_TabBarTearIndicatorRight = 0x37
        SE_PushButtonBevel        = 0x38
        SE_CustomBase             = 0xf0000000


class QStyleFactory(Shiboken.Object): ...


class QStyleHintReturn(Shiboken.Object):

    class HintReturnType(enum.Enum):

        SH_Default                = 0xf000
        SH_Mask                   = 0xf001
        SH_Variant                = 0xf002

    class StyleOptionType(enum.Enum):

        Type                      = 0xf000

    class StyleOptionVersion(enum.Enum):

        Version                   = 0x1


class QStyleHintReturnMask(PySide6.QtWidgets.QStyleHintReturn):

    class StyleOptionType(enum.Enum):

        Type                      = 0xf001

    class StyleOptionVersion(enum.Enum):

        Version                   = 0x1


class QStyleHintReturnVariant(PySide6.QtWidgets.QStyleHintReturn):

    class StyleOptionType(enum.Enum):

        Type                      = 0xf002

    class StyleOptionVersion(enum.Enum):

        Version                   = 0x1


class QStyleOption(Shiboken.Object):

    class OptionType(enum.Enum):

        SO_Default                = 0x0
        SO_FocusRect              = 0x1
        SO_Button                 = 0x2
        SO_Tab                    = 0x3
        SO_MenuItem               = 0x4
        SO_Frame                  = 0x5
        SO_ProgressBar            = 0x6
        SO_ToolBox                = 0x7
        SO_Header                 = 0x8
        SO_DockWidget             = 0x9
        SO_ViewItem               = 0xa
        SO_TabWidgetFrame         = 0xb
        SO_TabBarBase             = 0xc
        SO_RubberBand             = 0xd
        SO_ToolBar                = 0xe
        SO_GraphicsItem           = 0xf
        SO_CustomBase             = 0xf00
        SO_Complex                = 0xf0000
        SO_Slider                 = 0xf0001
        SO_SpinBox                = 0xf0002
        SO_ToolButton             = 0xf0003
        SO_ComboBox               = 0xf0004
        SO_TitleBar               = 0xf0005
        SO_GroupBox               = 0xf0006
        SO_SizeGrip               = 0xf0007
        SO_ComplexCustomBase      = 0xf000000

    class StyleOptionType(enum.Enum):

        Type                      = 0x0

    class StyleOptionVersion(enum.Enum):

        Version                   = 0x1


    def __repr__(self, /) -> str: ...


class QStyleOptionButton(PySide6.QtWidgets.QStyleOption):

    class ButtonFeature(enum.Flag):

        None_                     = 0x0
        Flat                      = 0x1
        HasMenu                   = 0x2
        DefaultButton             = 0x4
        AutoDefaultButton         = 0x8
        CommandLinkButton         = 0x10

    class StyleOptionType(enum.Enum):

        Type                      = 0x2

    class StyleOptionVersion(enum.Enum):

        Version                   = 0x1


class QStyleOptionComboBox(PySide6.QtWidgets.QStyleOptionComplex):

    class StyleOptionType(enum.Enum):

        Type                      = 0xf0004

    class StyleOptionVersion(enum.Enum):

        Version                   = 0x1


class QStyleOptionComplex(PySide6.QtWidgets.QStyleOption):

    class StyleOptionType(enum.Enum):

        Type                      = 0xf0000

    class StyleOptionVersion(enum.Enum):

        Version                   = 0x1


class QStyleOptionDockWidget(PySide6.QtWidgets.QStyleOption):

    class StyleOptionType(enum.Enum):

        Type                      = 0x9

    class StyleOptionVersion(enum.Enum):

        Version                   = 0x1


class QStyleOptionFocusRect(PySide6.QtWidgets.QStyleOption):

    class StyleOptionType(enum.Enum):

        Type                      = 0x1

    class StyleOptionVersion(enum.Enum):

        Version                   = 0x1


class QStyleOptionFrame(PySide6.QtWidgets.QStyleOption):

    class FrameFeature(enum.Flag):

        None_                     = 0x0
        Flat                      = 0x1
        Rounded                   = 0x2

    class StyleOptionType(enum.Enum):

        Type                      = 0x5

    class StyleOptionVersion(enum.Enum):

        Version                   = 0x1


class QStyleOptionGraphicsItem(PySide6.QtWidgets.QStyleOption):

    class StyleOptionType(enum.Enum):

        Type                      = 0xf

    class StyleOptionVersion(enum.Enum):

        Version                   = 0x1


class QStyleOptionGroupBox(PySide6.QtWidgets.QStyleOptionComplex):

    class StyleOptionType(enum.Enum):

        Type                      = 0xf0006

    class StyleOptionVersion(enum.Enum):

        Version                   = 0x1


class QStyleOptionHeader(PySide6.QtWidgets.QStyleOption):

    class SectionPosition(enum.Enum):

        Beginning                 = 0x0
        Middle                    = 0x1
        End                       = 0x2
        OnlyOneSection            = 0x3

    class SelectedPosition(enum.Enum):

        NotAdjacent               = 0x0
        NextIsSelected            = 0x1
        PreviousIsSelected        = 0x2
        NextAndPreviousAreSelected = 0x3

    class SortIndicator(enum.Enum):

        None_                     = 0x0
        SortUp                    = 0x1
        SortDown                  = 0x2

    class StyleOptionType(enum.Enum):

        Type                      = 0x8

    class StyleOptionVersion(enum.Enum):

        Version                   = 0x1


class QStyleOptionHeaderV2(PySide6.QtWidgets.QStyleOptionHeader):

    class StyleOptionType(enum.Enum):

        Type                      = 0x8

    class StyleOptionVersion(enum.Enum):

        Version                   = 0x2


class QStyleOptionMenuItem(PySide6.QtWidgets.QStyleOption):

    class CheckType(enum.Enum):

        NotCheckable              = 0x0
        Exclusive                 = 0x1
        NonExclusive              = 0x2

    class MenuItemType(enum.Enum):

        Normal                    = 0x0
        DefaultItem               = 0x1
        Separator                 = 0x2
        SubMenu                   = 0x3
        Scroller                  = 0x4
        TearOff                   = 0x5
        Margin                    = 0x6
        EmptyArea                 = 0x7

    class StyleOptionType(enum.Enum):

        Type                      = 0x4

    class StyleOptionVersion(enum.Enum):

        Version                   = 0x1


class QStyleOptionProgressBar(PySide6.QtWidgets.QStyleOption):

    class StyleOptionType(enum.Enum):

        Type                      = 0x6

    class StyleOptionVersion(enum.Enum):

        Version                   = 0x1


class QStyleOptionRubberBand(PySide6.QtWidgets.QStyleOption):

    class StyleOptionType(enum.Enum):

        Type                      = 0xd

    class StyleOptionVersion(enum.Enum):

        Version                   = 0x1


class QStyleOptionSizeGrip(PySide6.QtWidgets.QStyleOptionComplex):

    class StyleOptionType(enum.Enum):

        Type                      = 0xf0007

    class StyleOptionVersion(enum.Enum):

        Version                   = 0x1


class QStyleOptionSlider(PySide6.QtWidgets.QStyleOptionComplex):

    class StyleOptionType(enum.Enum):

        Type                      = 0xf0001

    class StyleOptionVersion(enum.Enum):

        Version                   = 0x1


class QStyleOptionSpinBox(PySide6.QtWidgets.QStyleOptionComplex):

    class StyleOptionType(enum.Enum):

        Type                      = 0xf0002

    class StyleOptionVersion(enum.Enum):

        Version                   = 0x1


class QStyleOptionTab(PySide6.QtWidgets.QStyleOption):

    class CornerWidget(enum.Flag):

        NoCornerWidgets           = 0x0
        LeftCornerWidget          = 0x1
        RightCornerWidget         = 0x2

    class SelectedPosition(enum.Enum):

        NotAdjacent               = 0x0
        NextIsSelected            = 0x1
        PreviousIsSelected        = 0x2

    class StyleOptionType(enum.Enum):

        Type                      = 0x3

    class StyleOptionVersion(enum.Enum):

        Version                   = 0x1

    class TabFeature(enum.Flag):

        None_                     = 0x0
        HasFrame                  = 0x1
        MinimumSizeHint           = 0x2

    class TabPosition(enum.Enum):

        Beginning                 = 0x0
        Middle                    = 0x1
        End                       = 0x2
        OnlyOneTab                = 0x3
        Moving                    = 0x4


class QStyleOptionTabBarBase(PySide6.QtWidgets.QStyleOption):

    class StyleOptionType(enum.Enum):

        Type                      = 0xc

    class StyleOptionVersion(enum.Enum):

        Version                   = 0x1


class QStyleOptionTabWidgetFrame(PySide6.QtWidgets.QStyleOption):

    class StyleOptionType(enum.Enum):

        Type                      = 0xb

    class StyleOptionVersion(enum.Enum):

        Version                   = 0x1


class QStyleOptionTitleBar(PySide6.QtWidgets.QStyleOptionComplex):

    class StyleOptionType(enum.Enum):

        Type                      = 0xf0005

    class StyleOptionVersion(enum.Enum):

        Version                   = 0x1


class QStyleOptionToolBar(PySide6.QtWidgets.QStyleOption):

    class StyleOptionType(enum.Enum):

        Type                      = 0xe

    class StyleOptionVersion(enum.Enum):

        Version                   = 0x1

    class ToolBarFeature(enum.Flag):

        None_                     = 0x0
        Movable                   = 0x1

    class ToolBarPosition(enum.Enum):

        Beginning                 = 0x0
        Middle                    = 0x1
        End                       = 0x2
        OnlyOne                   = 0x3


class QStyleOptionToolBox(PySide6.QtWidgets.QStyleOption):

    class SelectedPosition(enum.Enum):

        NotAdjacent               = 0x0
        NextIsSelected            = 0x1
        PreviousIsSelected        = 0x2

    class StyleOptionType(enum.Enum):

        Type                      = 0x7

    class StyleOptionVersion(enum.Enum):

        Version                   = 0x1

    class TabPosition(enum.Enum):

        Beginning                 = 0x0
        Middle                    = 0x1
        End                       = 0x2
        OnlyOneTab                = 0x3


class QStyleOptionToolButton(PySide6.QtWidgets.QStyleOptionComplex):

    class StyleOptionType(enum.Enum):

        Type                      = 0xf0003

    class StyleOptionVersion(enum.Enum):

        Version                   = 0x1

    class ToolButtonFeature(enum.Flag):

        None_                     = 0x0
        Arrow                     = 0x1
        Menu                      = 0x4
        MenuButtonPopup           = 0x4
        PopupDelay                = 0x8
        HasMenu                   = 0x10


class QStyleOptionViewItem(PySide6.QtWidgets.QStyleOption):

    class Position(enum.Enum):

        Left                      = 0x0
        Right                     = 0x1
        Top                       = 0x2
        Bottom                    = 0x3

    class StyleOptionType(enum.Enum):

        Type                      = 0xa

    class StyleOptionVersion(enum.Enum):

        Version                   = 0x1

    class ViewItemFeature(enum.Flag):

        None_                     = 0x0
        WrapText                  = 0x1
        Alternate                 = 0x2
        HasCheckIndicator         = 0x4
        HasDisplay                = 0x8
        HasDecoration             = 0x10
        IsDecoratedRootColumn     = 0x20
        IsDecorationForRootColumn = 0x40

    class ViewItemPosition(enum.Enum):

        Invalid                   = 0x0
        Beginning                 = 0x1
        Middle                    = 0x2
        End                       = 0x3
        OnlyOne                   = 0x4


class QStylePainter(PySide6.QtGui.QPainter): ...


class QStyledItemDelegate(PySide6.QtWidgets.QAbstractItemDelegate): ...


class QSwipeGesture(PySide6.QtWidgets.QGesture):

    class SwipeDirection(enum.Enum):

        NoDirection               = 0x0
        Left                      = 0x1
        Right                     = 0x2
        Up                        = 0x3
        Down                      = 0x4


class QSystemTrayIcon(PySide6.QtCore.QObject):

    activated                : typing.ClassVar[Signal] = ... # activated(QSystemTrayIcon::ActivationReason)
    messageClicked           : typing.ClassVar[Signal] = ... # messageClicked()

    class ActivationReason(enum.Enum):

        Unknown                   = 0x0
        Context                   = 0x1
        DoubleClick               = 0x2
        Trigger                   = 0x3
        MiddleClick               = 0x4

    class MessageIcon(enum.Enum):

        NoIcon                    = 0x0
        Information               = 0x1
        Warning                   = 0x2
        Critical                  = 0x3


class QTabBar(PySide6.QtWidgets.QWidget):

    currentChanged           : typing.ClassVar[Signal] = ... # currentChanged(int)
    tabBarClicked            : typing.ClassVar[Signal] = ... # tabBarClicked(int)
    tabBarDoubleClicked      : typing.ClassVar[Signal] = ... # tabBarDoubleClicked(int)
    tabCloseRequested        : typing.ClassVar[Signal] = ... # tabCloseRequested(int)
    tabMoved                 : typing.ClassVar[Signal] = ... # tabMoved(int,int)

    class ButtonPosition(enum.Enum):

        LeftSide                  = 0x0
        RightSide                 = 0x1

    class SelectionBehavior(enum.Enum):

        SelectLeftTab             = 0x0
        SelectRightTab            = 0x1
        SelectPreviousTab         = 0x2

    class Shape(enum.Enum):

        RoundedNorth              = 0x0
        RoundedSouth              = 0x1
        RoundedWest               = 0x2
        RoundedEast               = 0x3
        TriangularNorth           = 0x4
        TriangularSouth           = 0x5
        TriangularWest            = 0x6
        TriangularEast            = 0x7


class QTabWidget(PySide6.QtWidgets.QWidget):

    currentChanged           : typing.ClassVar[Signal] = ... # currentChanged(int)
    tabBarClicked            : typing.ClassVar[Signal] = ... # tabBarClicked(int)
    tabBarDoubleClicked      : typing.ClassVar[Signal] = ... # tabBarDoubleClicked(int)
    tabCloseRequested        : typing.ClassVar[Signal] = ... # tabCloseRequested(int)

    class TabPosition(enum.Enum):

        North                     = 0x0
        South                     = 0x1
        West                      = 0x2
        East                      = 0x3

    class TabShape(enum.Enum):

        Rounded                   = 0x0
        Triangular                = 0x1


class QTableView(PySide6.QtWidgets.QAbstractItemView): ...


class QTableWidget(PySide6.QtWidgets.QTableView):

    cellActivated            : typing.ClassVar[Signal] = ... # cellActivated(int,int)
    cellChanged              : typing.ClassVar[Signal] = ... # cellChanged(int,int)
    cellClicked              : typing.ClassVar[Signal] = ... # cellClicked(int,int)
    cellDoubleClicked        : typing.ClassVar[Signal] = ... # cellDoubleClicked(int,int)
    cellEntered              : typing.ClassVar[Signal] = ... # cellEntered(int,int)
    cellPressed              : typing.ClassVar[Signal] = ... # cellPressed(int,int)
    currentCellChanged       : typing.ClassVar[Signal] = ... # currentCellChanged(int,int,int,int)
    currentItemChanged       : typing.ClassVar[Signal] = ... # currentItemChanged(QTableWidgetItem*,QTableWidgetItem*)
    itemActivated            : typing.ClassVar[Signal] = ... # itemActivated(QTableWidgetItem*)
    itemChanged              : typing.ClassVar[Signal] = ... # itemChanged(QTableWidgetItem*)
    itemClicked              : typing.ClassVar[Signal] = ... # itemClicked(QTableWidgetItem*)
    itemDoubleClicked        : typing.ClassVar[Signal] = ... # itemDoubleClicked(QTableWidgetItem*)
    itemEntered              : typing.ClassVar[Signal] = ... # itemEntered(QTableWidgetItem*)
    itemPressed              : typing.ClassVar[Signal] = ... # itemPressed(QTableWidgetItem*)
    itemSelectionChanged     : typing.ClassVar[Signal] = ... # itemSelectionChanged()


class QTableWidgetItem(Shiboken.Object):

    class ItemType(enum.IntEnum):

        Type                      = 0x0
        UserType                  = 0x3e8


class QTableWidgetSelectionRange(Shiboken.Object): ...


class QTapAndHoldGesture(PySide6.QtWidgets.QGesture): ...


class QTapGesture(PySide6.QtWidgets.QGesture): ...


class QTextBrowser(PySide6.QtWidgets.QTextEdit):

    anchorClicked            : typing.ClassVar[Signal] = ... # anchorClicked(QUrl)
    backwardAvailable        : typing.ClassVar[Signal] = ... # backwardAvailable(bool)
    forwardAvailable         : typing.ClassVar[Signal] = ... # forwardAvailable(bool)
    highlighted              : typing.ClassVar[Signal] = ... # highlighted(QUrl)
    historyChanged           : typing.ClassVar[Signal] = ... # historyChanged()
    sourceChanged            : typing.ClassVar[Signal] = ... # sourceChanged(QUrl)


class QTextEdit(PySide6.QtWidgets.QAbstractScrollArea):

    copyAvailable            : typing.ClassVar[Signal] = ... # copyAvailable(bool)
    currentCharFormatChanged : typing.ClassVar[Signal] = ... # currentCharFormatChanged(QTextCharFormat)
    cursorPositionChanged    : typing.ClassVar[Signal] = ... # cursorPositionChanged()
    redoAvailable            : typing.ClassVar[Signal] = ... # redoAvailable(bool)
    selectionChanged         : typing.ClassVar[Signal] = ... # selectionChanged()
    textChanged              : typing.ClassVar[Signal] = ... # textChanged()
    undoAvailable            : typing.ClassVar[Signal] = ... # undoAvailable(bool)

    class AutoFormattingFlag(enum.Flag):

        AutoNone                  = 0x0
        AutoBulletList            = 0x1
        AutoAll                   = 0xffffffff

    class ExtraSelection(Shiboken.Object): ...

    class LineWrapMode(enum.Enum):

        NoWrap                    = 0x0
        WidgetWidth               = 0x1
        FixedPixelWidth           = 0x2
        FixedColumnWidth          = 0x3


class QTileRules(Shiboken.Object): ...


class QTimeEdit(PySide6.QtWidgets.QDateTimeEdit):

    userTimeChanged          : typing.ClassVar[Signal] = ... # userTimeChanged(QTime)


class QToolBar(PySide6.QtWidgets.QWidget):

    actionTriggered          : typing.ClassVar[Signal] = ... # actionTriggered(QAction*)
    allowedAreasChanged      : typing.ClassVar[Signal] = ... # allowedAreasChanged(Qt::ToolBarAreas)
    iconSizeChanged          : typing.ClassVar[Signal] = ... # iconSizeChanged(QSize)
    movableChanged           : typing.ClassVar[Signal] = ... # movableChanged(bool)
    orientationChanged       : typing.ClassVar[Signal] = ... # orientationChanged(Qt::Orientation)
    toolButtonStyleChanged   : typing.ClassVar[Signal] = ... # toolButtonStyleChanged(Qt::ToolButtonStyle)
    topLevelChanged          : typing.ClassVar[Signal] = ... # topLevelChanged(bool)
    visibilityChanged        : typing.ClassVar[Signal] = ... # visibilityChanged(bool)


class QToolBox(PySide6.QtWidgets.QFrame):

    currentChanged           : typing.ClassVar[Signal] = ... # currentChanged(int)


class QToolButton(PySide6.QtWidgets.QAbstractButton):

    triggered                : typing.ClassVar[Signal] = ... # triggered(QAction*)

    class ToolButtonPopupMode(enum.Enum):

        DelayedPopup              = 0x0
        MenuButtonPopup           = 0x1
        InstantPopup              = 0x2


class QToolTip(Shiboken.Object): ...


class QTreeView(PySide6.QtWidgets.QAbstractItemView):

    collapsed                : typing.ClassVar[Signal] = ... # collapsed(QModelIndex)
    expanded                 : typing.ClassVar[Signal] = ... # expanded(QModelIndex)


class QTreeWidget(PySide6.QtWidgets.QTreeView):

    currentItemChanged       : typing.ClassVar[Signal] = ... # currentItemChanged(QTreeWidgetItem*,QTreeWidgetItem*)
    itemActivated            : typing.ClassVar[Signal] = ... # itemActivated(QTreeWidgetItem*,int)
    itemChanged              : typing.ClassVar[Signal] = ... # itemChanged(QTreeWidgetItem*,int)
    itemClicked              : typing.ClassVar[Signal] = ... # itemClicked(QTreeWidgetItem*,int)
    itemCollapsed            : typing.ClassVar[Signal] = ... # itemCollapsed(QTreeWidgetItem*)
    itemDoubleClicked        : typing.ClassVar[Signal] = ... # itemDoubleClicked(QTreeWidgetItem*,int)
    itemEntered              : typing.ClassVar[Signal] = ... # itemEntered(QTreeWidgetItem*,int)
    itemExpanded             : typing.ClassVar[Signal] = ... # itemExpanded(QTreeWidgetItem*)
    itemPressed              : typing.ClassVar[Signal] = ... # itemPressed(QTreeWidgetItem*,int)
    itemSelectionChanged     : typing.ClassVar[Signal] = ... # itemSelectionChanged()


class QTreeWidgetItem(Shiboken.Object):

    class ChildIndicatorPolicy(enum.Enum):

        ShowIndicator             = 0x0
        DontShowIndicator         = 0x1
        DontShowIndicatorWhenChildless = 0x2

    class ItemType(enum.IntEnum):

        Type                      = 0x0
        UserType                  = 0x3e8


class QTreeWidgetItemIterator(Shiboken.Object):

    class IteratorFlag(enum.Flag):

        All                       = 0x0
        Hidden                    = 0x1
        NotHidden                 = 0x2
        Selected                  = 0x4
        Unselected                = 0x8
        Selectable                = 0x10
        NotSelectable             = 0x20
        DragEnabled               = 0x40
        DragDisabled              = 0x80
        DropEnabled               = 0x100
        DropDisabled              = 0x200
        HasChildren               = 0x400
        NoChildren                = 0x800
        Checked                   = 0x1000
        NotChecked                = 0x2000
        Enabled                   = 0x4000
        Disabled                  = 0x8000
        Editable                  = 0x10000
        NotEditable               = 0x20000
        UserFlag                  = 0x1000000


class QUndoView(PySide6.QtWidgets.QListView): ...


class QVBoxLayout(PySide6.QtWidgets.QBoxLayout): ...


class QWhatsThis(Shiboken.Object): ...


class QWidget(PySide6.QtCore.QObject, PySide6.QtGui.QPaintDevice):

    customContextMenuRequested: typing.ClassVar[Signal] = ... # customContextMenuRequested(QPoint)
    windowIconChanged        : typing.ClassVar[Signal] = ... # windowIconChanged(QIcon)
    windowIconTextChanged    : typing.ClassVar[Signal] = ... # windowIconTextChanged(QString)
    windowTitleChanged       : typing.ClassVar[Signal] = ... # windowTitleChanged(QString)

    class RenderFlag(enum.Flag):

        DrawWindowBackground      = 0x1
        DrawChildren              = 0x2
        IgnoreMask                = 0x4


    def __repr__(self, /) -> str: ...


class QWidgetAction(PySide6.QtGui.QAction): ...


class QWidgetItem(PySide6.QtWidgets.QLayoutItem): ...


class QWizard(PySide6.QtWidgets.QDialog):

    currentIdChanged         : typing.ClassVar[Signal] = ... # currentIdChanged(int)
    customButtonClicked      : typing.ClassVar[Signal] = ... # customButtonClicked(int)
    helpRequested            : typing.ClassVar[Signal] = ... # helpRequested()
    pageAdded                : typing.ClassVar[Signal] = ... # pageAdded(int)
    pageRemoved              : typing.ClassVar[Signal] = ... # pageRemoved(int)

    class WizardButton(enum.Enum):

        NoButton                  = -1
        BackButton                = 0x0
        NextButton                = 0x1
        CommitButton              = 0x2
        FinishButton              = 0x3
        CancelButton              = 0x4
        HelpButton                = 0x5
        CustomButton1             = 0x6
        NStandardButtons          = 0x6
        CustomButton2             = 0x7
        CustomButton3             = 0x8
        NButtons                  = 0x9
        Stretch                   = 0x9

    class WizardOption(enum.Flag):

        IndependentPages          = 0x1
        IgnoreSubTitles           = 0x2
        ExtendedWatermarkPixmap   = 0x4
        NoDefaultButton           = 0x8
        NoBackButtonOnStartPage   = 0x10
        NoBackButtonOnLastPage    = 0x20
        DisabledBackButtonOnLastPage = 0x40
        HaveNextButtonOnLastPage  = 0x80
        HaveFinishButtonOnEarlyPages = 0x100
        NoCancelButton            = 0x200
        CancelButtonOnLeft        = 0x400
        HaveHelpButton            = 0x800
        HelpButtonOnRight         = 0x1000
        HaveCustomButton1         = 0x2000
        HaveCustomButton2         = 0x4000
        HaveCustomButton3         = 0x8000
        NoCancelButtonOnLastPage  = 0x10000

    class WizardPixmap(enum.Enum):

        WatermarkPixmap           = 0x0
        LogoPixmap                = 0x1
        BannerPixmap              = 0x2
        BackgroundPixmap          = 0x3
        NPixmaps                  = 0x4

    class WizardStyle(enum.Enum):

        ClassicStyle              = 0x0
        ModernStyle               = 0x1
        MacStyle                  = 0x2
        AeroStyle                 = 0x3
        NStyles                   = 0x4


class QWizardPage(PySide6.QtWidgets.QWidget):

    completeChanged          : typing.ClassVar[Signal] = ... # completeChanged()


# eof
